
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef icu_ERROR_H
#define icu_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_icu    (7480)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_icu_SOMEBODY             H2_ENCODE_ERR(M_icu       , 1)
#define S_icu_BAD_PARAMETERS       H2_ENCODE_ERR(M_icu       , 2)
#define S_icu_NOBODY               H2_ENCODE_ERR(M_icu       , 3)
#define S_icu_NO_PROCESS_RUNNING   H2_ENCODE_ERR(M_icu       , 4)
#define S_icu_TRACK_IT_FAILED      H2_ENCODE_ERR(M_icu       , 5)
#define S_icu_INIT_DISPLAY_FAILED  H2_ENCODE_ERR(M_icu       , 6)


/* std errors */
#define S_icu_stdGenoM_ACTIVITY_INTERRUPTED       490267649   /* 7480<<16 | 0x8000 | 100<<8 | 1 */
#define S_icu_stdGenoM_TOO_MANY_ACTIVITIES        490267650   /* 7480<<16 | 0x8000 | 100<<8 | 2 */
#define S_icu_stdGenoM_ACTIVITY_FAILED            490267651   /* 7480<<16 | 0x8000 | 100<<8 | 3 */
#define S_icu_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 490267652   /* 7480<<16 | 0x8000 | 100<<8 | 4 */
#define S_icu_stdGenoM_UNKNOWN_ACTIVITY           490267653   /* 7480<<16 | 0x8000 | 100<<8 | 5 */
#define S_icu_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 490267654   /* 7480<<16 | 0x8000 | 100<<8 | 6 */
#define S_icu_stdGenoM_SYSTEM_ERROR               490267655   /* 7480<<16 | 0x8000 | 100<<8 | 7 */
#define S_icu_stdGenoM_ACTIVITY_ALREADY_ENDED     490267656   /* 7480<<16 | 0x8000 | 100<<8 | 8 */
#define S_icu_stdGenoM_WAIT_INIT_RQST             490267657   /* 7480<<16 | 0x8000 | 100<<8 | 9 */
#define S_icu_stdGenoM_CONTROL_CODEL_ERROR        490267658   /* 7480<<16 | 0x8000 | 100<<8 | 10 */
#define S_icu_stdGenoM_EXEC_TASK_SUSPENDED        490267659   /* 7480<<16 | 0x8000 | 100<<8 | 11 */
#define S_icu_stdGenoM_BAD_BLOCK_TYPE             490267660   /* 7480<<16 | 0x8000 | 100<<8 | 12 */
#define S_icu_stdGenoM_BAD_POSTER_TYPE            490267661   /* 7480<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define ICU_H2_ERR_MSGS {\
    {"SOMEBODY", 1},\
    {"BAD_PARAMETERS", 2},\
    {"NOBODY", 3},\
    {"NO_PROCESS_RUNNING", 4},\
    {"TRACK_IT_FAILED", 5},\
    {"INIT_DISPLAY_FAILED", 6},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int icuRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
