
/* --- Generated file, do not edit by hand --------------------------- */

/* 
 * Copyright (c) 1993-2010 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*
 * icuHeader.h 
 *
 * Include this file in codels _only_
 */

#ifndef icu_HEADER_H
#define icu_HEADER_H

#if defined(__RTAI__) && defined(__KERNEL__)
# include <linux/kernel.h>
# include <linux/sched.h>
#else
# include <stdio.h>
# include <string.h>
#endif

#include <portLib.h>

/* Inclusions concernant le module */
#include "icuPosterLib.h"

#ifdef __cplusplus
extern "C" {
#endif
#include "icuPosterWriteLibProto.h"
#include "icuPosterReadLibProto.h"
#ifdef __cplusplus
}
#endif

/* Inclusions des bibliotheques des serveurs du module */



/* Nombre de types requetes definies pour ce serveur */
#define NB_RQST_TYPE                   (34+1)

/* Declaration des structures de donnees */
extern ICU_CNTRL_STR *icuCntrlStrId;
extern struct ICU_STR *icuDataStrId;

#define SDI_C (icuCntrlStrId)
#define SDI_F (icuDataStrId)



#define ICU_RESULTS_POSTER_ID (icuCntrlStrId->execTaskTab[ICU_RUNTASK_NUM].posterId[0])
#define ICU_HUMANPRESENCE_POSTER_ID (icuCntrlStrId->execTaskTab[ICU_RUNTASK_NUM].posterId[1])
#define ICU_PLATINECMD_POSTER_ID (icuCntrlStrId->execTaskTab[ICU_RUNTASK_NUM].posterId[2])
#define ICU_VISUALDATA_POSTER_ID (icuCntrlStrId->execTaskTab[ICU_RUNTASK_NUM].posterId[3])

#define ICU_RUNTASK_NUM (0)



/* User functions signatures */
#ifdef __cplusplus
extern "C" {
#endif

extern ACTIVITY_EVENT icuInitDisplayExec(ICU_AFFICHAGE *(in_display), int *bilan);
extern STATUS icuPomTaggingCntrl(int *(tag_on_off), int *bilan);
extern STATUS icuAutoModeCntrl(ICU_AUTOSWITCH_CONTROL *(autoSwitchControl), int *bilan);
extern STATUS icuSaveFaceCntrl(int *(save_face), int *bilan);
extern STATUS icuCaptureImageCntrl(int *(captureImage), int *bilan);
extern ACTIVITY_EVENT icuCaptureImageExec(int *(in_captureImage), int *bilan);
extern STATUS icuCaptureVideoCntrl(int *(captureVideo), int *bilan);
extern STATUS icuSetViamPosterCntrl(str *(viamPosterName), int *bilan);
extern STATUS icuEnableDisplayCntrl(ICU_AFFICHAGE *(display), int *bilan);
extern ACTIVITY_EVENT icuEnableDisplayExec(ICU_AFFICHAGE *(in_display), int *bilan);
extern STATUS icuSetCameraPosCntrl(ICU_CAMERA_POS *(cameraPos), int *bilan);
extern ACTIVITY_EVENT icuSetCameraPosExec(ICU_CAMERA_POS *(in_cameraPos), int *bilan);
extern ACTIVITY_EVENT icuTrackItExec(int *(in_track_it), int *bilan);
extern STATUS icuWaitForSomebodyCntrl(int *(nbImageMaxNobody), int *bilan);
extern ACTIVITY_EVENT icuWaitForSomebodyExec(int *(in_nbImageMaxNobody), ICU_WAITFOR *(out_waitFor), int *bilan);
extern STATUS icuWaitForSomeoneCntrl(ICU_WAITFOR *(waitFor), int *bilan);
extern ACTIVITY_EVENT icuWaitForSomeoneStart(ICU_WAITFOR *(in_waitFor), int *bilan);
extern ACTIVITY_EVENT icuWaitForSomeoneExec(ICU_WAITFOR *(in_waitFor), int *bilan);
extern STATUS icuWaitForNobodyCntrl(int *(nbImageMaxNobody), int *bilan);
extern ACTIVITY_EVENT icuWaitForNobodyExec(int *(in_nbImageMaxNobody), int *bilan);
extern STATUS icuWaitForNoneCntrl(ICU_WAITFOR *(waitFor), int *bilan);
extern ACTIVITY_EVENT icuWaitForNoneStart(ICU_WAITFOR *(in_waitFor), int *bilan);
extern ACTIVITY_EVENT icuWaitForNoneExec(ICU_WAITFOR *(in_waitFor), int *bilan);
extern STATUS icuWaitForNobodyKnownCntrl(int *(nbImageMaxNobody), int *bilan);
extern ACTIVITY_EVENT icuWaitForNobodyKnownExec(int *(in_nbImageMaxNobody), int *bilan);
extern STATUS icuWaitForPersonListChangeCntrl(ICU_PERSON_LIST_PARAMS *(paramsPersonList), int *bilan);
extern ACTIVITY_EVENT icuWaitForPersonListChangeExec(ICU_PERSON_LIST_PARAMS *(in_paramsPersonList), ICU_WAITFOR *(out_waitFor), int *bilan);
extern STATUS icuProcessSetModalityCntrl(ICU_MODALITIES *(setModality), int *bilan);
extern ACTIVITY_EVENT icuProcessSetModalityExec(ICU_MODALITIES *(in_setModality), int *bilan);
extern STATUS icuFacerecSetWorkingPathCntrl(GEN_STRING256 *(facerecWorkingPath), int *bilan);
extern ACTIVITY_EVENT icuFacerecSetWorkingPathExec(GEN_STRING256 *(in_facerecWorkingPath), int *bilan);
extern STATUS icuFacerecSetParamsCntrl(ICU_PERSON_LIST_PARAMS *(paramsPersonList), int *bilan);
extern STATUS icuFacerecInitCntrl(int *bilan);
extern ACTIVITY_EVENT icuFacerecInitExec(int *bilan);
extern STATUS icuFacerecAddSomebodyCntrl(GEN_STRING256 *(recoAddName), int *bilan);
extern ACTIVITY_EVENT icuFacerecAddSomebodyExec(GEN_STRING256 *(in_recoAddName), int *bilan);
extern STATUS icuFacerecSetPeopleCntrl(GEN_STRING256 *(recoName), int *bilan);
extern ACTIVITY_EVENT icuFacerecSetPeopleExec(GEN_STRING256 *(in_recoName), int *bilan);
extern STATUS icuFacerecRecognizeAllCntrl(int *bilan);
extern ACTIVITY_EVENT icuFacerecRecognizeAllExec(int *bilan);
extern STATUS icuFacerecLoadSomebodyCntrl(GEN_STRING256 *(recoName), int *bilan);
extern ACTIVITY_EVENT icuFacerecLoadSomebodyExec(GEN_STRING256 *(in_recoName), int *bilan);
extern STATUS icuFacerecUnloadSomebodyCntrl(GEN_STRING256 *(recoName), int *bilan);
extern ACTIVITY_EVENT icuFacerecUnloadSomebodyExec(GEN_STRING256 *(in_recoName), int *bilan);
extern STATUS icuFacerecLoadEverybodyCntrl(int *bilan);
extern ACTIVITY_EVENT icuFacerecLoadEverybodyExec(int *bilan);
extern STATUS icuFacerecUnloadEverybodyCntrl(int *bilan);
extern ACTIVITY_EVENT icuFacerecUnloadEverybodyExec(int *bilan);
extern STATUS icuWaitForModalityChangeCntrl(int *bilan);
extern ACTIVITY_EVENT icuWaitForModalityChangeExec(int *bilan);
extern STATUS icuLaunchPlatineCntrl(ICU_PLATINE_PARAMS *(platineParams), int *bilan);
extern ACTIVITY_EVENT icuLaunchPlatineExecStart(ICU_PLATINE_PARAMS *(in_platineParams), int *bilan);
extern ACTIVITY_EVENT icuLaunchPlatineExec(ICU_PLATINE_PARAMS *(in_platineParams), int *bilan);
extern ACTIVITY_EVENT icuCmdPtu(int *bilan);
extern STATUS icuInitRFIDCntrl(int *bilan);
extern ACTIVITY_EVENT icuInitRFIDExec(int *bilan);
extern STATUS icuCloseRFIDCntrl(int *bilan);
extern ACTIVITY_EVENT icuCloseRFIDExec(int *bilan);
extern STATUS icuAcquireRFIDCntrl(int *bilan);
extern ACTIVITY_EVENT icuAcquireRFIDExec(int *bilan);
extern STATUS icuAcquireTagCntrl(GEN_STRING256 *(recoTag), int *bilan);
extern ACTIVITY_EVENT icuAcquireTagExec(GEN_STRING256 *(in_recoTag), int *bilan);
extern STATUS icuRunTaskInit(int *bilan);
extern STATUS icuRunTaskEnd(void);
extern STATUS icuRunTaskExec(int *bilan);


#ifdef __cplusplus
}
#endif


/**
 ** Macros to acces the SDI_C
 **
 ** To be used with the following parameters:
 **
 ** p: SDI_C   t: <MODULE>_<TASK>_NUM    a: CURRENT_ACTIVITY_NUM(t)
 **
 ** t can be also replaced by the macro: CURRENT_EXEC_TASK
 **
 **/

/* The execution task  */
#define EXEC_TASK_ID(t)         M_EXEC_TASK_ID(SDI_C,t)
#define EXEC_TASK_STATUS(t)     M_EXEC_TASK_STATUS(SDI_C,t)
#define EXEC_TASK_PERIOD(t)     M_EXEC_TASK_PERIOD(SDI_C,t)
#define EXEC_TASK_MAX_PERIOD(t) M_EXEC_TASK_MAX_PERIOD(SDI_C,t)
#define EXEC_TASK_ON_PERIOD(t)  M_EXEC_TASK_ON_PERIOD(SDI_C,t)
#define EXEC_TASK_DURATION_LOOP(t) M_EXEC_TASK_DURATION_LOOP(SDI_C,t)
#define EXEC_TASK_BILAN(t)      M_EXEC_TASK_BILAN(SDI_C,t)
#define EXEC_TASK_NB_ACTI(t)    M_EXEC_TASK_NB_ACTI(SDI_C,t)
#define EXEC_TASK_DONTLOCK_SDI(t) M_EXEC_TASK_DONTLOCK_SDI(SDI_C,t)
#define EXEC_TASK_POSTER_ID(t)  M_EXEC_TASK_POSTER_ID(SDI_C,t)
#define CURRENT_ACTIVITY_NUM(t) M_CURRENT_ACTIVITY_NUM(SDI_C,t)
#define EXEC_TASK_WAKE_UP_FLAG(t) M_EXEC_TASK_WAKE_UP_FLAG(SDI_C,t)
#define CURRENT_EXEC_TASK         M_CURRENT_EXEC_TASK(SDI_C)

/* The activities */
#define ACTIVITY_OUTPUT_ID(a)   M_ACTIVITY_OUTPUT_ID(SDI_C,a)
#define ACTIVITY_OUTPUT_SIZE(a) M_ACTIVITY_OUTPUT_SIZE(SDI_C,a)
#define ACTIVITY_INPUT_ID(a)    M_ACTIVITY_INPUT_ID(SDI_C,a)
#define ACTIVITY_INPUT_SIZE(a)  M_ACTIVITY_INPUT_SIZE(SDI_C,a)
#define ACTIVITY_RQST_ID(a)     M_ACTIVITY_RQST_ID(SDI_C,a)
#define ACTIVITY_RQST_TYPE(a)   M_ACTIVITY_RQST_TYPE(SDI_C,a)
#define ACTIVITY_ID(a)          M_ACTIVITY_ID(SDI_C,a)
#define ACTIVITY_TASK_NUM(a)    M_ACTIVITY_TASK_NUM(SDI_C,a)
#define ACTIVITY_STATUS(a)      M_ACTIVITY_STATUS(SDI_C,a)
#define ACTIVITY_EVN(a)         M_ACTIVITY_EVN(SDI_C,a)
#define ACTIVITY_BILAN(a)       M_ACTIVITY_BILAN(SDI_C,a)
#define ACTIVITY_REENTRANCE(a)  M_ACTIVITY_REENTRANCE(SDI_C,a)
#define ACTIVITY_NB_INCOMP(a)   M_ACTIVITY_NB_INCOMP(SDI_C,a)
#define ACTIVITY_TAB_INCOMP(a)  M_ACTIVITY_TAB_INCOMP(SDI_C,a)
 
/* The control task */
#define CNTRL_TASK_ID          M_CNTRL_TASK_ID(SDI_C)
#define CNTRL_TASK_STATUS      M_CNTRL_TASK_STATUS(SDI_C)
#define CNTRL_TASK_BILAN       M_CNTRL_TASK_BILAN(SDI_C)
#define NB_ACTIVITIES          M_NB_ACTIVITIES(SDI_C)
#define STOP_MODULE_FLAG       M_STOP_MODULE_FLAG(SDI_C)
#define INIT_RQST              M_INIT_RQST(SDI_C)
#define CNTRL_NB_EXEC_TASKS    M_CNTRL_NB_EXEC_TASKS(SDI_C)
#define CNTRL_SDI_F            M_CNTRL_SDI_F(SDI_C)

#define GENOM_VERBOSE_LEVEL    M_GENOM_VERBOSE_LEVEL(SDI_C)
#define GENOM_PRINT_TIME_FLAG  M_GENOM_PRINT_TIME_FLAG(SDI_C)

#define GENOM_VERBOSE(fmt, args...) {\
    if(GENOM_VERBOSE_LEVEL>=1){fprintf(stderr,"icu: "fmt"\n", ##args);}\
}

#define GENOM_PRINT(fmt, args...) {\
fprintf(stderr, \
        "icu %s(): "fmt "\n"\
        "icu %s(): file %s, line %d\n", \
         __func__,  ##args, \
         __func__,  __FILE__, __LINE__);\
}

#define GENOM_PRINT_REPORT(report) {\
fprintf(stderr, \
        "icu %s(): " #report "\n" \
        "icu %s(): file %s, line %d\n", \
         __func__,  \
         __func__,  __FILE__, __LINE__);			\
}

#define GENOM_UNLOCK_SDI       M_GENOM_UNLOCK_SDI(SDI_C)
#define GENOM_LOCK_SDI         M_GENOM_LOCK_SDI(SDI_C)

/* Macros */

/* Wakeup an exec task */
#define WAKE_UP_EXEC_TASK(t)       (EXEC_TASK_WAKE_UP_FLAG(t) = TRUE)
/* Abort an activity
 * ONLY FOR CONTROL TASK */
#define CNTRL_ABORT_ACTIVITY(p,a)    (ACTIVITY_EVN(a) = INTER)
 

/*-------------------- Fin de chargement du fichier -----------------------*/

#endif
