
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef icu_MSG_LIB_H
#define icu_MSG_LIB_H

#include "portLib.h"
#include "csLib.h"
#include "posterLib.h"
 
#include "icuType.h"

#define TIME_WAIT_REPLY           /*2000*/ 0
 



/*----------- Tailles des messages et boites aux lettres  ----------*/

/* Taille du buffer utilise dans la bal pour un mesage de taille size
 * (cf servMbox pour UNIX et h2rgnLib pour VXWORKS )
 */


#define BUF_SIZE(size) \
   (size + 4 - (size & 3) + sizeof(LETTER_HDR) + 8)

/**
 ** Boite aux lettres reception requetes 
 **/
#define  ICU_MBOX_NAME                      "icu"

#define  ICU_MAX_RQST_SIZE              260

#define  ICU_MBOX_RQST_SIZE       \
 (BUF_SIZE(ICU_MAX_RQST_SIZE) * SERV_NMAX_RQST_ID)

/** 
 ** Taille max repliques (serveur)
 **/
#define  ICU_MAX_INTERMED_REPLY_SIZE   (sizeof(int))

#define  ICU_MAX_REPLY_SIZE             260

/** 
 ** Taille bal clients pour reception repliques 
 **/
#define  ICU_CLIENT_MBOX_REPLY_SIZE   \
((BUF_SIZE(ICU_MAX_REPLY_SIZE) \
   + BUF_SIZE(ICU_MAX_INTERMED_REPLY_SIZE)) \
 * CLIENT_NMAX_RQST_ID)

/*-------------------------- Liste des requetes  -------------------------*/

#define ICU_INITDISPLAY_RQST 0
#define ICU_POMTAGGING_RQST 1
#define ICU_AUTOMODE_RQST 2
#define ICU_SAVEFACE_RQST 3
#define ICU_CAPTUREIMAGE_RQST 4
#define ICU_CAPTUREVIDEO_RQST 5
#define ICU_SETVIAMPOSTERNAME_RQST 6
#define ICU_ENABLEDISPLAY_RQST 7
#define ICU_SETCAMERAPOS_RQST 8
#define ICU_TRACKIT_RQST 9
#define ICU_WAITFORSOMEBODY_RQST 10
#define ICU_WAITFORSOMEONE_RQST 11
#define ICU_WAITFORNOBODY_RQST 12
#define ICU_WAITFORNONE_RQST 13
#define ICU_WAITFORNOBODYKNOWN_RQST 14
#define ICU_WAITFORPERSONLISTCHANGE_RQST 15
#define ICU_PROCESSSETMODALITY_RQST 16
#define ICU_FACERECSETWORKINGPATH_RQST 17
#define ICU_FACERECSETPARAMS_RQST 18
#define ICU_FACERECINIT_RQST 19
#define ICU_FACERECADDSOMEBODY_RQST 20
#define ICU_FACERECSETPEOPLE_RQST 21
#define ICU_FACERECRECOGNIZEALL_RQST 22
#define ICU_FACERECLOADSOMEBODY_RQST 23
#define ICU_FACERECUNLOADSOMEBODY_RQST 24
#define ICU_FACERECLOADEVERYBODY_RQST 25
#define ICU_FACERECUNLOADEVERYBODY_RQST 26
#define ICU_WAITFORMODALITYCHANGE_RQST 27
#define ICU_LAUNCHPLATINE_RQST 28
#define ICU_CMDPTU_RQST 29
#define ICU_ICUINITRFID_RQST 30
#define ICU_ICUCLOSERFID_RQST 31
#define ICU_ICUACQUIRERFID_RQST 32
#define ICU_ICUACQUIRETAG_RQST 33
#define ICU_ABORT_RQST 34


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

STATUS icuClientInit (CLIENT_ID *pClientId);

STATUS icuClientEnd (CLIENT_ID clientId);

int icuAbortRqstSend (CLIENT_ID clientId, 
			   int *pRqstId,
			   int *activity,
			   int replyTimeOut);

int icuAbortReplyRcv (CLIENT_ID clientId, 
			   int rqstId, 
			   int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			   int *bilan);

int icuAbortRqstAndRcv (CLIENT_ID clientId, 
			     int *activity,
			     int *bilan);




extern STATUS icuInitDisplayRqstSend (CLIENT_ID clientId, int *pRqstId,
					 ICU_AFFICHAGE *(in_display),
					 int replyTimeOut);

extern int icuInitDisplayReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuInitDisplayRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					ICU_AFFICHAGE *(in_display), 
					
					int *activity, int *bilan);

extern int icuInitDisplayRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					ICU_AFFICHAGE *(in_display), 
					
					int *activity,
					int *bilan);




extern STATUS icuPomTaggingRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 int *(in_tag_on_off),
					 int replyTimeOut);

int icuPomTaggingReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int icuPomTaggingRqstAndRcv (CLIENT_ID clientId, 
				 int *(in_tag_on_off), 
				 
				 int *bilan);




extern STATUS icuAutoModeRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 ICU_AUTOSWITCH_CONTROL *(in_autoSwitchControl),
					 int replyTimeOut);

int icuAutoModeReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int icuAutoModeRqstAndRcv (CLIENT_ID clientId, 
				 ICU_AUTOSWITCH_CONTROL *(in_autoSwitchControl), 
				 
				 int *bilan);




extern STATUS icuSaveFaceRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 int *(in_save_face),
					 int replyTimeOut);

int icuSaveFaceReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int icuSaveFaceRqstAndRcv (CLIENT_ID clientId, 
				 int *(in_save_face), 
				 
				 int *bilan);




extern STATUS icuCaptureImageRqstSend (CLIENT_ID clientId, int *pRqstId,
					 int *(in_captureImage),
					 int replyTimeOut);

extern int icuCaptureImageReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuCaptureImageRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					int *(in_captureImage), 
					
					int *activity, int *bilan);

extern int icuCaptureImageRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					int *(in_captureImage), 
					
					int *activity,
					int *bilan);




extern STATUS icuCaptureVideoRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 int *(in_captureVideo),
					 int replyTimeOut);

int icuCaptureVideoReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int icuCaptureVideoRqstAndRcv (CLIENT_ID clientId, 
				 int *(in_captureVideo), 
				 
				 int *bilan);




extern STATUS icuSetViamPosterNameRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 str *(in_viamPosterName),
					 int replyTimeOut);

int icuSetViamPosterNameReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int icuSetViamPosterNameRqstAndRcv (CLIENT_ID clientId, 
				 str *(in_viamPosterName), 
				 
				 int *bilan);




extern STATUS icuEnableDisplayRqstSend (CLIENT_ID clientId, int *pRqstId,
					 ICU_AFFICHAGE *(in_display),
					 int replyTimeOut);

extern int icuEnableDisplayReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuEnableDisplayRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					ICU_AFFICHAGE *(in_display), 
					
					int *activity, int *bilan);

extern int icuEnableDisplayRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					ICU_AFFICHAGE *(in_display), 
					
					int *activity,
					int *bilan);




extern STATUS icuSetCameraPosRqstSend (CLIENT_ID clientId, int *pRqstId,
					 ICU_CAMERA_POS *(in_cameraPos),
					 int replyTimeOut);

extern int icuSetCameraPosReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuSetCameraPosRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					ICU_CAMERA_POS *(in_cameraPos), 
					
					int *activity, int *bilan);

extern int icuSetCameraPosRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					ICU_CAMERA_POS *(in_cameraPos), 
					
					int *activity,
					int *bilan);




extern STATUS icuTrackItRqstSend (CLIENT_ID clientId, int *pRqstId,
					 int *(in_track_it),
					 int replyTimeOut);

extern int icuTrackItReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuTrackItRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					int *(in_track_it), 
					
					int *activity, int *bilan);

extern int icuTrackItRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					int *(in_track_it), 
					
					int *activity,
					int *bilan);




extern STATUS icuWaitForSomebodyRqstSend (CLIENT_ID clientId, int *pRqstId,
					 int *(in_nbImageMaxNobody),
					 int replyTimeOut);

extern int icuWaitForSomebodyReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      ICU_WAITFOR *(out_waitFor),
				      int *activity, int *bilan);


extern int icuWaitForSomebodyRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					int *(in_nbImageMaxNobody), 
					ICU_WAITFOR *(out_waitFor),
					int *activity, int *bilan);

extern int icuWaitForSomebodyRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					int *(in_nbImageMaxNobody), 
					ICU_WAITFOR *(out_waitFor),
					int *activity,
					int *bilan);




extern STATUS icuWaitForSomeoneRqstSend (CLIENT_ID clientId, int *pRqstId,
					 ICU_WAITFOR *(in_waitFor),
					 int replyTimeOut);

extern int icuWaitForSomeoneReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuWaitForSomeoneRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					ICU_WAITFOR *(in_waitFor), 
					
					int *activity, int *bilan);

extern int icuWaitForSomeoneRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					ICU_WAITFOR *(in_waitFor), 
					
					int *activity,
					int *bilan);




extern STATUS icuWaitForNobodyRqstSend (CLIENT_ID clientId, int *pRqstId,
					 int *(in_nbImageMaxNobody),
					 int replyTimeOut);

extern int icuWaitForNobodyReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuWaitForNobodyRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					int *(in_nbImageMaxNobody), 
					
					int *activity, int *bilan);

extern int icuWaitForNobodyRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					int *(in_nbImageMaxNobody), 
					
					int *activity,
					int *bilan);




extern STATUS icuWaitForNoneRqstSend (CLIENT_ID clientId, int *pRqstId,
					 ICU_WAITFOR *(in_waitFor),
					 int replyTimeOut);

extern int icuWaitForNoneReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuWaitForNoneRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					ICU_WAITFOR *(in_waitFor), 
					
					int *activity, int *bilan);

extern int icuWaitForNoneRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					ICU_WAITFOR *(in_waitFor), 
					
					int *activity,
					int *bilan);




extern STATUS icuWaitForNobodyKnownRqstSend (CLIENT_ID clientId, int *pRqstId,
					 int *(in_nbImageMaxNobody),
					 int replyTimeOut);

extern int icuWaitForNobodyKnownReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuWaitForNobodyKnownRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					int *(in_nbImageMaxNobody), 
					
					int *activity, int *bilan);

extern int icuWaitForNobodyKnownRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					int *(in_nbImageMaxNobody), 
					
					int *activity,
					int *bilan);




extern STATUS icuWaitForPersonListChangeRqstSend (CLIENT_ID clientId, int *pRqstId,
					 ICU_PERSON_LIST_PARAMS *(in_paramsPersonList),
					 int replyTimeOut);

extern int icuWaitForPersonListChangeReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      ICU_WAITFOR *(out_waitFor),
				      int *activity, int *bilan);


extern int icuWaitForPersonListChangeRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					ICU_PERSON_LIST_PARAMS *(in_paramsPersonList), 
					ICU_WAITFOR *(out_waitFor),
					int *activity, int *bilan);

extern int icuWaitForPersonListChangeRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					ICU_PERSON_LIST_PARAMS *(in_paramsPersonList), 
					ICU_WAITFOR *(out_waitFor),
					int *activity,
					int *bilan);




extern STATUS icuProcessSetModalityRqstSend (CLIENT_ID clientId, int *pRqstId,
					 ICU_MODALITIES *(in_setModality),
					 int replyTimeOut);

extern int icuProcessSetModalityReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuProcessSetModalityRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					ICU_MODALITIES *(in_setModality), 
					
					int *activity, int *bilan);

extern int icuProcessSetModalityRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					ICU_MODALITIES *(in_setModality), 
					
					int *activity,
					int *bilan);




extern STATUS icuFacerecSetWorkingPathRqstSend (CLIENT_ID clientId, int *pRqstId,
					 GEN_STRING256 *(in_facerecWorkingPath),
					 int replyTimeOut);

extern int icuFacerecSetWorkingPathReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuFacerecSetWorkingPathRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					GEN_STRING256 *(in_facerecWorkingPath), 
					
					int *activity, int *bilan);

extern int icuFacerecSetWorkingPathRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					GEN_STRING256 *(in_facerecWorkingPath), 
					
					int *activity,
					int *bilan);




extern STATUS icuFacerecSetParamsRqstSend (CLIENT_ID clientId, int *pRqstId,
					 ICU_PERSON_LIST_PARAMS *(in_paramsPersonList),
					 int replyTimeOut);

extern int icuFacerecSetParamsReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuFacerecSetParamsRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					ICU_PERSON_LIST_PARAMS *(in_paramsPersonList), 
					
					int *activity, int *bilan);

extern int icuFacerecSetParamsRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					ICU_PERSON_LIST_PARAMS *(in_paramsPersonList), 
					
					int *activity,
					int *bilan);




extern STATUS icuFacerecInitRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int icuFacerecInitReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuFacerecInitRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int icuFacerecInitRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS icuFacerecAddSomebodyRqstSend (CLIENT_ID clientId, int *pRqstId,
					 GEN_STRING256 *(in_recoAddName),
					 int replyTimeOut);

extern int icuFacerecAddSomebodyReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuFacerecAddSomebodyRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					GEN_STRING256 *(in_recoAddName), 
					
					int *activity, int *bilan);

extern int icuFacerecAddSomebodyRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					GEN_STRING256 *(in_recoAddName), 
					
					int *activity,
					int *bilan);




extern STATUS icuFacerecSetPeopleRqstSend (CLIENT_ID clientId, int *pRqstId,
					 GEN_STRING256 *(in_recoName),
					 int replyTimeOut);

extern int icuFacerecSetPeopleReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuFacerecSetPeopleRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					GEN_STRING256 *(in_recoName), 
					
					int *activity, int *bilan);

extern int icuFacerecSetPeopleRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					GEN_STRING256 *(in_recoName), 
					
					int *activity,
					int *bilan);




extern STATUS icuFacerecRecognizeAllRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int icuFacerecRecognizeAllReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuFacerecRecognizeAllRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int icuFacerecRecognizeAllRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS icuFacerecLoadSomebodyRqstSend (CLIENT_ID clientId, int *pRqstId,
					 GEN_STRING256 *(in_recoName),
					 int replyTimeOut);

extern int icuFacerecLoadSomebodyReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuFacerecLoadSomebodyRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					GEN_STRING256 *(in_recoName), 
					
					int *activity, int *bilan);

extern int icuFacerecLoadSomebodyRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					GEN_STRING256 *(in_recoName), 
					
					int *activity,
					int *bilan);




extern STATUS icuFacerecUnloadSomebodyRqstSend (CLIENT_ID clientId, int *pRqstId,
					 GEN_STRING256 *(in_recoName),
					 int replyTimeOut);

extern int icuFacerecUnloadSomebodyReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuFacerecUnloadSomebodyRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					GEN_STRING256 *(in_recoName), 
					
					int *activity, int *bilan);

extern int icuFacerecUnloadSomebodyRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					GEN_STRING256 *(in_recoName), 
					
					int *activity,
					int *bilan);




extern STATUS icuFacerecLoadEverybodyRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int icuFacerecLoadEverybodyReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuFacerecLoadEverybodyRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int icuFacerecLoadEverybodyRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS icuFacerecUnloadEverybodyRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int icuFacerecUnloadEverybodyReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuFacerecUnloadEverybodyRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int icuFacerecUnloadEverybodyRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS icuWaitForModalityChangeRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int icuWaitForModalityChangeReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuWaitForModalityChangeRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int icuWaitForModalityChangeRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS icuLaunchPlatineRqstSend (CLIENT_ID clientId, int *pRqstId,
					 ICU_PLATINE_PARAMS *(in_platineParams),
					 int replyTimeOut);

extern int icuLaunchPlatineReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuLaunchPlatineRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					ICU_PLATINE_PARAMS *(in_platineParams), 
					
					int *activity, int *bilan);

extern int icuLaunchPlatineRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					ICU_PLATINE_PARAMS *(in_platineParams), 
					
					int *activity,
					int *bilan);




extern STATUS icuCmdPtuRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int icuCmdPtuReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuCmdPtuRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int icuCmdPtuRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS icuIcuInitRFIDRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int icuIcuInitRFIDReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuIcuInitRFIDRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int icuIcuInitRFIDRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS icuIcuCloseRFIDRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int icuIcuCloseRFIDReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuIcuCloseRFIDRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int icuIcuCloseRFIDRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS icuIcuAcquireRFIDRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int icuIcuAcquireRFIDReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuIcuAcquireRFIDRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int icuIcuAcquireRFIDRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS icuIcuAcquireTagRqstSend (CLIENT_ID clientId, int *pRqstId,
					 GEN_STRING256 *(in_recoTag),
					 int replyTimeOut);

extern int icuIcuAcquireTagReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int icuIcuAcquireTagRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					GEN_STRING256 *(in_recoTag), 
					
					int *activity, int *bilan);

extern int icuIcuAcquireTagRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					GEN_STRING256 *(in_recoTag), 
					
					int *activity,
					int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* icu_MSG_LIB_H */

