
/* 
 * Copyright (c) 2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*
 * Automatically generated by GenoM : do not edit by hand
 * Read data from the posters produced by the module icu
 */


#include <stdio.h>
#include <stdlib.h>

#include <portLib.h>

#include "icuPosterLib.h"
#include "icuPrint.h"
#include "icuEndian.h"

#include <genom/h2endian.h>

/* Id. du poster de controle */
static POSTER_ID icuCntrlPosterId=(POSTER_ID)NULL;
static H2_ENDIANNESS posterDataEndianness;

/*  prototypes de la bibliotheque printState */
extern char const * h2GetEvnStateString(int num);

/* ---------------- LE POSTER DE CONTROLE ------------------------------ */

/* ----------------------------------------------------------------------
 *
 *  icuCntrlPosterRead - Lecture du poster de controle du module
 *
 */

POSTER_ID icuCntrlPosterID () { return icuCntrlPosterId; }

STATUS icuCntrlPosterRead (ICU_CNTRL_STR *icuCntrlStrId)
{  
  if (!icuCntrlPosterId)
    icuCntrlPosterInit();
  if (posterRead (icuCntrlPosterId, 0, (void *) icuCntrlStrId, 
	      sizeof(ICU_CNTRL_STR)) != sizeof(ICU_CNTRL_STR))
    return ERROR; 
  return OK;
}

/* ---------------- LES POSTERS FONCTIONNELS ------------------------------ */

static POSTER_ID ResultsPosterId=(POSTER_ID)NULL;
static POSTER_ID HumanPresencePosterId=(POSTER_ID)NULL;
static POSTER_ID PlatineCmdPosterId=(POSTER_ID)NULL;
static POSTER_ID VisualDataPosterId=(POSTER_ID)NULL;

/* -- posterInit ------------------------------------------------------- */

STATUS icuPosterInit(void)
{
  int status = OK;

  icuRecordH2errMsgs();

  if (icuCntrlPosterInit() == ERROR) {
    status = ERROR;
  }
  if (icuResultsPosterInit() == ERROR) {
    status = ERROR;
  }
  if (icuHumanPresencePosterInit() == ERROR) {
    status = ERROR;
  }
  if (icuPlatineCmdPosterInit() == ERROR) {
    status = ERROR;
  }
  if (icuVisualDataPosterInit() == ERROR) {
    status = ERROR;
  }
  return(status);
}

/* --  Cntrl ------------------------------------------------- */

STATUS icuCntrlPosterInit(void)
{
  if (posterFind(ICU_CNTRL_POSTER_NAME, &icuCntrlPosterId) == ERROR) {
     h2perror("icuCntrlPosterInit");
     return ERROR;
  }
  if (posterEndianness(icuCntrlPosterId, &posterDataEndianness) == ERROR) {
    h2perror("icuCntrlPosterInit");
    return ERROR;
  }
  return OK;
}

/* --  Results ------------------------------------------------- */

STATUS icuResultsPosterInit(void)
{
  if (posterFind(ICU_RESULTS_POSTER_NAME, &ResultsPosterId) == ERROR) {
     h2perror("icuResultsPosterInit");
     return ERROR;
  }
  if (posterEndianness(ResultsPosterId, &posterDataEndianness) == ERROR) {
    h2perror("icuResultsPosterInit");
    return ERROR;
  }
  return OK;
}

/* --  HumanPresence ------------------------------------------------- */

STATUS icuHumanPresencePosterInit(void)
{
  if (posterFind(ICU_HUMANPRESENCE_POSTER_NAME, &HumanPresencePosterId) == ERROR) {
     h2perror("icuHumanPresencePosterInit");
     return ERROR;
  }
  if (posterEndianness(HumanPresencePosterId, &posterDataEndianness) == ERROR) {
    h2perror("icuHumanPresencePosterInit");
    return ERROR;
  }
  return OK;
}

/* --  PlatineCmd ------------------------------------------------- */

STATUS icuPlatineCmdPosterInit(void)
{
  if (posterFind(ICU_PLATINECMD_POSTER_NAME, &PlatineCmdPosterId) == ERROR) {
     h2perror("icuPlatineCmdPosterInit");
     return ERROR;
  }
  if (posterEndianness(PlatineCmdPosterId, &posterDataEndianness) == ERROR) {
    h2perror("icuPlatineCmdPosterInit");
    return ERROR;
  }
  return OK;
}

/* --  VisualData ------------------------------------------------- */

STATUS icuVisualDataPosterInit(void)
{
  if (posterFind(ICU_VISUALDATA_POSTER_NAME, &VisualDataPosterId) == ERROR) {
     h2perror("icuVisualDataPosterInit");
     return ERROR;
  }
  if (posterEndianness(VisualDataPosterId, &posterDataEndianness) == ERROR) {
    h2perror("icuVisualDataPosterInit");
    return ERROR;
  }
  return OK;
}

/* --  Results ------------------------------------------------- */

POSTER_ID icuResultsPosterID() { return ResultsPosterId; }
STATUS icuResultsPosterRead(ICU_RESULTS_POSTER_STR *x)
{
  if (ResultsPosterId == (POSTER_ID)NULL) {
     if (icuResultsPosterInit() == ERROR) {
        h2perror("icuResultsPosterInit");
        return ERROR;
     }
  }
  if (posterRead(ResultsPosterId, 0, (char *)x, sizeof(*x))
           != sizeof(*x)) {
    h2perror("icuResultsPosterRead:");
    return ERROR;
  }
  if (posterDataEndianness != H2_LOCAL_ENDIANNESS)
     endianswap_struct_ICU_RESULTS_POSTER_STR(x, 0, NULL);
  return OK;
}

/* --  Results -> humanPos ---------------------------------------- */

STATUS icuResultshumanPosPosterRead(ICU_HUMAN_POS *humanPos /* struct ICU_HUMAN_POS */)
{
  ICU_RESULTS_POSTER_STR *x = NULL;
  int offset = (int)&(x->humanPos) - (int)(x);
  int size = sizeof(x->humanPos);
  int *dims = NULL;

  if (ResultsPosterId == (POSTER_ID)NULL) {
     if (icuResultsPosterInit() == ERROR) {
        h2perror("icuResultsPosterInit");
        return ERROR;
     }
  }
  if (posterRead(ResultsPosterId, offset, (char *)(humanPos), size) != size) {
    h2perror("icuResultsPosterRead read");
    return ERROR;
  }
  if (posterDataEndianness != H2_LOCAL_ENDIANNESS)
     endianswap_struct_ICU_HUMAN_POS(humanPos, 0, dims);
  return OK;
}

/* --  HumanPresence ------------------------------------------------- */

POSTER_ID icuHumanPresencePosterID() { return HumanPresencePosterId; }
STATUS icuHumanPresencePosterRead(ICU_HUMANPRESENCE_POSTER_STR *x)
{
  if (HumanPresencePosterId == (POSTER_ID)NULL) {
     if (icuHumanPresencePosterInit() == ERROR) {
        h2perror("icuHumanPresencePosterInit");
        return ERROR;
     }
  }
  if (posterRead(HumanPresencePosterId, 0, (char *)x, sizeof(*x))
           != sizeof(*x)) {
    h2perror("icuHumanPresencePosterRead:");
    return ERROR;
  }
  if (posterDataEndianness != H2_LOCAL_ENDIANNESS)
     endianswap_struct_ICU_HUMANPRESENCE_POSTER_STR(x, 0, NULL);
  return OK;
}

/* --  HumanPresence -> loadedPersonList ---------------------------------------- */

STATUS icuHumanPresenceloadedPersonListPosterRead(ICU_RECOGNITION_WHOLIST *loadedPersonList /* struct ICU_RECOGNITION_WHOLIST */)
{
  ICU_HUMANPRESENCE_POSTER_STR *x = NULL;
  int offset = (int)&(x->loadedPersonList) - (int)(x);
  int size = sizeof(x->loadedPersonList);
  int *dims = NULL;

  if (HumanPresencePosterId == (POSTER_ID)NULL) {
     if (icuHumanPresencePosterInit() == ERROR) {
        h2perror("icuHumanPresencePosterInit");
        return ERROR;
     }
  }
  if (posterRead(HumanPresencePosterId, offset, (char *)(loadedPersonList), size) != size) {
    h2perror("icuHumanPresencePosterRead read");
    return ERROR;
  }
  if (posterDataEndianness != H2_LOCAL_ENDIANNESS)
     endianswap_struct_ICU_RECOGNITION_WHOLIST(loadedPersonList, 0, dims);
  return OK;
}

/* --  PlatineCmd ------------------------------------------------- */

POSTER_ID icuPlatineCmdPosterID() { return PlatineCmdPosterId; }
STATUS icuPlatineCmdPosterRead(ICU_PLATINECMD_POSTER_STR *x)
{
  if (PlatineCmdPosterId == (POSTER_ID)NULL) {
     if (icuPlatineCmdPosterInit() == ERROR) {
        h2perror("icuPlatineCmdPosterInit");
        return ERROR;
     }
  }
  if (posterRead(PlatineCmdPosterId, 0, (char *)x, sizeof(*x))
           != sizeof(*x)) {
    h2perror("icuPlatineCmdPosterRead:");
    return ERROR;
  }
  if (posterDataEndianness != H2_LOCAL_ENDIANNESS)
     endianswap_struct_ICU_PLATINECMD_POSTER_STR(x, 0, NULL);
  return OK;
}

/* --  PlatineCmd -> cmdPlatine ---------------------------------------- */

STATUS icuPlatineCmdcmdPlatinePosterRead(PLATINE_AXIS_STR *cmdPlatine /* struct PLATINE_AXIS_STR */)
{
  ICU_PLATINECMD_POSTER_STR *x = NULL;
  int offset = (int)&(x->cmdPlatine) - (int)(x);
  int size = sizeof(x->cmdPlatine);
  int *dims = NULL;

  if (PlatineCmdPosterId == (POSTER_ID)NULL) {
     if (icuPlatineCmdPosterInit() == ERROR) {
        h2perror("icuPlatineCmdPosterInit");
        return ERROR;
     }
  }
  if (posterRead(PlatineCmdPosterId, offset, (char *)(cmdPlatine), size) != size) {
    h2perror("icuPlatineCmdPosterRead read");
    return ERROR;
  }
  if (posterDataEndianness != H2_LOCAL_ENDIANNESS)
     endianswap_struct_PLATINE_AXIS_STR(cmdPlatine, 0, dims);
  return OK;
}

/* --  VisualData ------------------------------------------------- */

POSTER_ID icuVisualDataPosterID() { return VisualDataPosterId; }
STATUS icuVisualDataPosterRead(ICU_VISUALDATA_POSTER_STR *x)
{
  if (VisualDataPosterId == (POSTER_ID)NULL) {
     if (icuVisualDataPosterInit() == ERROR) {
        h2perror("icuVisualDataPosterInit");
        return ERROR;
     }
  }
  if (posterRead(VisualDataPosterId, 0, (char *)x, sizeof(*x))
           != sizeof(*x)) {
    h2perror("icuVisualDataPosterRead:");
    return ERROR;
  }
  if (posterDataEndianness != H2_LOCAL_ENDIANNESS)
     endianswap_struct_ICU_VISUALDATA_POSTER_STR(x, 0, NULL);
  return OK;
}

/* --  VisualData -> Data ---------------------------------------- */

STATUS icuVisualDataDataPosterRead(ICU_VISUAL_DATA *Data /* struct ICU_VISUAL_DATA */)
{
  ICU_VISUALDATA_POSTER_STR *x = NULL;
  int offset = (int)&(x->Data) - (int)(x);
  int size = sizeof(x->Data);
  int *dims = NULL;

  if (VisualDataPosterId == (POSTER_ID)NULL) {
     if (icuVisualDataPosterInit() == ERROR) {
        h2perror("icuVisualDataPosterInit");
        return ERROR;
     }
  }
  if (posterRead(VisualDataPosterId, offset, (char *)(Data), size) != size) {
    h2perror("icuVisualDataPosterRead read");
    return ERROR;
  }
  if (posterDataEndianness != H2_LOCAL_ENDIANNESS)
     endianswap_struct_ICU_VISUAL_DATA(Data, 0, dims);
  return OK;
}


