
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef icu_POSTER_LIB_H
#define icu_POSTER_LIB_H

#include "posterLib.h"

/* Types definis ou utilises par le module */
#include "icuType.h"
#include "icuError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[ICU_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} ICU_CNTRL_STR;

/* For consistency with other posters */
typedef ICU_CNTRL_STR ICU_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "icuPosterLibStruct.h"



/* Posters */
#define ICU_CNTRL_POSTER_NAME         "icuCntrl"
#define ICU_RESULTS_POSTER_NAME "icuResults"
#define ICU_HUMANPRESENCE_POSTER_NAME "icuHumanPresence"
#define ICU_PLATINECMD_POSTER_NAME "icuPlatineCmd"
#define ICU_VISUALDATA_POSTER_NAME "icuVisualData"


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS icuPosterInit ( void );
extern POSTER_ID icuCntrlPosterID ();
extern STATUS icuCntrlPosterRead ( ICU_CNTRL_STR *icuCntrlStrId );
extern STATUS icuCntrlPosterInit ( void );
extern STATUS icuResultsPosterInit ( void );
extern POSTER_ID icuResultsPosterID ( void );
extern STATUS icuResultsPosterRead ( ICU_RESULTS_POSTER_STR *x );
extern STATUS icuResultshumanPosPosterRead ( ICU_HUMAN_POS *humanPos );
extern STATUS icuHumanPresencePosterInit ( void );
extern POSTER_ID icuHumanPresencePosterID ( void );
extern STATUS icuHumanPresencePosterRead ( ICU_HUMANPRESENCE_POSTER_STR *x );
extern STATUS icuHumanPresenceloadedPersonListPosterRead ( ICU_RECOGNITION_WHOLIST *loadedPersonList );
extern STATUS icuPlatineCmdPosterInit ( void );
extern POSTER_ID icuPlatineCmdPosterID ( void );
extern STATUS icuPlatineCmdPosterRead ( ICU_PLATINECMD_POSTER_STR *x );
extern STATUS icuPlatineCmdcmdPlatinePosterRead ( PLATINE_AXIS_STR *cmdPlatine );
extern STATUS icuVisualDataPosterInit ( void );
extern POSTER_ID icuVisualDataPosterID ( void );
extern STATUS icuVisualDataPosterRead ( ICU_VISUALDATA_POSTER_STR *x );
extern STATUS icuVisualDataDataPosterRead ( ICU_VISUAL_DATA *Data );
#ifdef __cplusplus
}
#endif
#endif

