
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*--------------  file automaticaly generated with GenoM -------------*/
/*-----------------------  DO NOT EDIT BY HAND -----------------------*/
 
/****************************************************************************/
/*   LABORATOIRE D'AUTOMATIQUE ET D'ANALYSE DE SYSTEMES - LAAS / CNRS       */
/*   PROJET HILARE II - INTERACTION PAR POSTER AVEC LE MODULE  ICU     */
/*   FICHIER SOURCE : "icuPosterLib.c"                                 */
/****************************************************************************/

/* DESCRIPTION :
   Bibliotheque de fonctions qui permettent la lecture ou l'affichage
   du contenu des posters du module
*/


#include <stdio.h>
#include <stdlib.h>
#include <portLib.h>

#include "icuPosterShowLib.h"
#include "icuPrint.h"


  
static char *icuExecTaskNameTab[] = {
"RunTask"
};

/*  prototypes de la bibliotheque printState */
extern char const * h2GetEvnStateString(int num);

static void icuActivityShow (ICU_CNTRL_STR *sdic);


/* ---------------- LE POSTER DE CONTROLE ------------------------------ */

/* ----------------------------------------------------------------------
 *
 *  icuCntrlPosterShow - Affichage du poster de controle du module
 *
 */

STATUS icuCntrlPosterShow ()
{
  char strmsg[64];
  ICU_CNTRL_STR *sdic;
  int i;

  /* Lecture de la SDI de controle */
  sdic = (ICU_CNTRL_STR *)malloc(sizeof(ICU_CNTRL_STR));
  if (sdic == NULL) {
    h2perror ("icuCntrlPosterShow");
    return ERROR;
  }
  if (icuCntrlPosterRead (sdic) != OK) {
    free(sdic);
    return ERROR;
  }

  /* 
   * Affichage 
   */

  printf ("-- TASKS           (status)      (last duration)         (bilan)\n");
  /* Tache de controle */
  printf (" Control Task        %-5s                               %s\n",  
	  M_CNTRL_TASK_STATUS(sdic)==OK ? "OK":"ERROR",
	  h2getErrMsg(M_CNTRL_TASK_BILAN(sdic), strmsg, 64));
  
  /* Taches d'execution */
  for (i=0; i<ICU_NB_EXEC_TASK; i++) {
    printf (" %d:%-15s   %-5s ",  
	    i, icuExecTaskNameTab[i],
	    M_EXEC_TASK_STATUS(sdic,i) == OK ? "OK": "ERROR");
    if (M_EXEC_TASK_PERIOD(sdic,i) != 0) {
      printf ("    %.2lfms ", M_EXEC_TASK_ON_PERIOD(sdic,i)/1000.0);
      printf ("(max %.2lf, ", M_EXEC_TASK_MAX_PERIOD(sdic,i)/1000.0);
      printf ("th %.2lf)", M_EXEC_TASK_PERIOD(sdic,i)*1000.);
    }
    else {
      printf ("    %.2lfms ", M_EXEC_TASK_ON_PERIOD(sdic,i)/1000.0);
      printf ("(max %.2lf)        ", M_EXEC_TASK_MAX_PERIOD(sdic,i)/1000.0);      
    }
    printf ("\t %s\n", h2getErrMsg(M_EXEC_TASK_BILAN(sdic,i), strmsg, 64));

  }
  printf ("\n");

  /* Activites */
  icuActivityShow (sdic);

  free(sdic);
  return OK;
}

STATUS icuCntrlPosterActivityShow ()
{
  ICU_CNTRL_STR *sdic;

  /* Lecture de la SDI de controle */
  sdic = (ICU_CNTRL_STR *)malloc(sizeof(ICU_CNTRL_STR));
  if (sdic == NULL) {
    h2perror ("icuCntrlPosterActivityShow");
    return ERROR;
  }
  if (icuCntrlPosterRead (sdic) != OK) {
    free(sdic);
    return ERROR;
  }

  icuActivityShow (sdic);

  free(sdic);
  return OK;
}

/* Fonciton locale d'affichage des activites */
static void icuActivityShow (ICU_CNTRL_STR *sdic)
{
#define ICU_NB_RQST_EXEC 29
#if ICU_NB_RQST_EXEC != 0

  
static char *icuExecRqstNameTab[] = {
"InitDisplay",
"CaptureImage",
"EnableDisplay",
"SetCameraPos",
"TrackIt",
"WaitForSomebody",
"WaitForSomeone",
"WaitForNobody",
"WaitForNone",
"WaitForNobodyKnown",
"WaitForPersonListChange",
"ProcessSetModality",
"FacerecSetWorkingPath",
"FacerecSetParams",
"FacerecInit",
"FacerecAddSomebody",
"FacerecSetPeople",
"FacerecRecognizeAll",
"FacerecLoadSomebody",
"FacerecUnloadSomebody",
"FacerecLoadEverybody",
"FacerecUnloadEverybody",
"WaitForModalityChange",
"LaunchPlatine",
"CmdPtu",
"IcuInitRFID",
"IcuCloseRFID",
"IcuAcquireRFID",
"IcuAcquireTag"
};
static int icuExecRqstNumTab[] = {
0, 4, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33};

  int i,oneActivity=FALSE;
  ACTIVITY_EVENT evn;
  ACTIVITY_STATE status;
  int bilan;
  int rqst;
  char strmsg[64];
  
  /*  printf (" ACTIVITY  REQUEST         TASK        FROM -> TO    BILAN\n");*/
  printf ("-- ACTIVITIES\n");
  for (i=0; i<MAX_ACTIVITIES; i++) {
    status = M_ACTIVITY_STATUS(sdic,i);
    bilan = M_ACTIVITY_BILAN(sdic,i);

    /* Affichage */
    if (status != ETHER || bilan != OK) {
      evn = M_ACTIVITY_EVN(sdic,i);
      
      /* Identification de la requete */
      rqst=0;
      while(icuExecRqstNumTab[rqst] != M_ACTIVITY_RQST_TYPE(sdic,i) 
	    && rqst<ICU_NB_RQST_EXEC)
	rqst++;

      if (status != ETHER) 
	oneActivity = TRUE;

      printf ("%s%2d  %2d:%-10s    %-10s\t%5s %s%s\n", 
	      status == ETHER ? " (" : "  ",

	      M_ACTIVITY_ID(sdic,i), 

	      rqst == ICU_NB_RQST_EXEC ? 
	      M_ACTIVITY_RQST_TYPE(sdic,i) : icuExecRqstNumTab[rqst],

	      rqst == ICU_NB_RQST_EXEC?
	      "Unknown" : icuExecRqstNameTab[rqst], 
	      
	      M_ACTIVITY_TASK_NUM(sdic,i) == -1 ? 
	      "not exec" : icuExecTaskNameTab[M_ACTIVITY_TASK_NUM(sdic,i)], 
	      
	      evn == NO_EVENT ?
	      h2GetEvnStateString(status) : h2GetEvnStateString(evn), 

	      h2getErrMsg(bilan, strmsg, 64),
	      
	      status == ETHER ? ")" : "");
    }

  }	/* for */
  if (!oneActivity) printf ("  No activity\n");
#endif /* ICU_NB_RQST_EXEC != 0 */
}

/* ---------------- LES POSTERS FONCTIONNELS ------------------------------ */

/* --  Results ------------------------------------------------- */

STATUS icuResultsPosterShow(void)
{
  ICU_RESULTS_POSTER_STR *x;

  if ((x = (ICU_RESULTS_POSTER_STR *)malloc(sizeof(* x))) == NULL) {
     h2perror("icuResultsPosterShow");
     return ERROR;
  }
  if (icuResultsPosterRead(x) == ERROR) {
     h2perror("icuResultsPosterShow");
     free(x);
     return ERROR;
  }
  print_struct_ICU_RESULTS_POSTER_STR(stdout, x, 0, 0, NULL, stdin);
  free(x);
  return OK;
}

/* --  Results -> humanPos ---------------------------------------- */

STATUS icuResultshumanPosPosterShow(void)
{
  ICU_HUMAN_POS *humanPos;
  int *dims = NULL;

  if ((humanPos = malloc(sizeof(struct ICU_HUMAN_POS))) == NULL) {
     h2perror("icuResultshumanPosPosterShow");
     return ERROR;
  }
  if (icuResultshumanPosPosterRead(humanPos) == ERROR) {
     h2perror("icuResultshumanPosPosterRead");
     free(humanPos);
     return ERROR;
  }
  printf ("humanPos:\n");
  print_struct_ICU_HUMAN_POS(stdout, humanPos, 1, 0, dims, stdin);
  free(humanPos);
  return OK;
}

/* --  HumanPresence ------------------------------------------------- */

STATUS icuHumanPresencePosterShow(void)
{
  ICU_HUMANPRESENCE_POSTER_STR *x;

  if ((x = (ICU_HUMANPRESENCE_POSTER_STR *)malloc(sizeof(* x))) == NULL) {
     h2perror("icuHumanPresencePosterShow");
     return ERROR;
  }
  if (icuHumanPresencePosterRead(x) == ERROR) {
     h2perror("icuHumanPresencePosterShow");
     free(x);
     return ERROR;
  }
  print_struct_ICU_HUMANPRESENCE_POSTER_STR(stdout, x, 0, 0, NULL, stdin);
  free(x);
  return OK;
}

/* --  HumanPresence -> loadedPersonList ---------------------------------------- */

STATUS icuHumanPresenceloadedPersonListPosterShow(void)
{
  ICU_RECOGNITION_WHOLIST *loadedPersonList;
  int *dims = NULL;

  if ((loadedPersonList = malloc(sizeof(struct ICU_RECOGNITION_WHOLIST))) == NULL) {
     h2perror("icuHumanPresenceloadedPersonListPosterShow");
     return ERROR;
  }
  if (icuHumanPresenceloadedPersonListPosterRead(loadedPersonList) == ERROR) {
     h2perror("icuHumanPresenceloadedPersonListPosterRead");
     free(loadedPersonList);
     return ERROR;
  }
  printf ("loadedPersonList:\n");
  print_struct_ICU_RECOGNITION_WHOLIST(stdout, loadedPersonList, 1, 0, dims, stdin);
  free(loadedPersonList);
  return OK;
}

/* --  PlatineCmd ------------------------------------------------- */

STATUS icuPlatineCmdPosterShow(void)
{
  ICU_PLATINECMD_POSTER_STR *x;

  if ((x = (ICU_PLATINECMD_POSTER_STR *)malloc(sizeof(* x))) == NULL) {
     h2perror("icuPlatineCmdPosterShow");
     return ERROR;
  }
  if (icuPlatineCmdPosterRead(x) == ERROR) {
     h2perror("icuPlatineCmdPosterShow");
     free(x);
     return ERROR;
  }
  print_struct_ICU_PLATINECMD_POSTER_STR(stdout, x, 0, 0, NULL, stdin);
  free(x);
  return OK;
}

/* --  PlatineCmd -> cmdPlatine ---------------------------------------- */

STATUS icuPlatineCmdcmdPlatinePosterShow(void)
{
  PLATINE_AXIS_STR *cmdPlatine;
  int *dims = NULL;

  if ((cmdPlatine = malloc(sizeof(struct PLATINE_AXIS_STR))) == NULL) {
     h2perror("icuPlatineCmdcmdPlatinePosterShow");
     return ERROR;
  }
  if (icuPlatineCmdcmdPlatinePosterRead(cmdPlatine) == ERROR) {
     h2perror("icuPlatineCmdcmdPlatinePosterRead");
     free(cmdPlatine);
     return ERROR;
  }
  printf ("cmdPlatine:\n");
  print_struct_PLATINE_AXIS_STR(stdout, cmdPlatine, 1, 0, dims, stdin);
  free(cmdPlatine);
  return OK;
}

/* --  VisualData ------------------------------------------------- */

STATUS icuVisualDataPosterShow(void)
{
  ICU_VISUALDATA_POSTER_STR *x;

  if ((x = (ICU_VISUALDATA_POSTER_STR *)malloc(sizeof(* x))) == NULL) {
     h2perror("icuVisualDataPosterShow");
     return ERROR;
  }
  if (icuVisualDataPosterRead(x) == ERROR) {
     h2perror("icuVisualDataPosterShow");
     free(x);
     return ERROR;
  }
  print_struct_ICU_VISUALDATA_POSTER_STR(stdout, x, 0, 0, NULL, stdin);
  free(x);
  return OK;
}

/* --  VisualData -> Data ---------------------------------------- */

STATUS icuVisualDataDataPosterShow(void)
{
  ICU_VISUAL_DATA *Data;
  int *dims = NULL;

  if ((Data = malloc(sizeof(struct ICU_VISUAL_DATA))) == NULL) {
     h2perror("icuVisualDataDataPosterShow");
     return ERROR;
  }
  if (icuVisualDataDataPosterRead(Data) == ERROR) {
     h2perror("icuVisualDataDataPosterRead");
     free(Data);
     return ERROR;
  }
  printf ("Data:\n");
  print_struct_ICU_VISUAL_DATA(stdout, Data, 1, 0, dims, stdin);
  free(Data);
  return OK;
}


