
/* --- FILE GENERATED WITH GENOM, DO NOT EDIT BY HAND ------------------ */

/* 
 * Copyright (c) 2003-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/* DESCRIPTION :
   Bibliotheque de fonctions qui permettent la lecture au format xml
   du contenu des posters du module depuis un XML
*/

#include <stdio.h>
#include <stdlib.h>

#include <portLib.h>
#include <h2timeLib.h>

#include "icuPosterLib.h"
#include "icuPosterXMLLib.h"
#include "icuPrintXML.h"

/*  prototypes de la bibliotheque printState */
extern char const * h2GetEvnStateString(int num);

  
static char *icuExecTaskNameTab[] = {
"RunTask"
};


static GENOM_POSTER_XML tabPosterXML[] = {
{"Cntrl", "", icuCntrlPosterXML},
{"Results", "", icuResultsPosterXML}, \
{"Results", "humanPos", icuResultshumanPosPosterXML}, \
{"HumanPresence", "", icuHumanPresencePosterXML}, \
{"HumanPresence", "loadedPersonList", icuHumanPresenceloadedPersonListPosterXML}, \
{"PlatineCmd", "", icuPlatineCmdPosterXML}, \
{"PlatineCmd", "cmdPlatine", icuPlatineCmdcmdPlatinePosterXML}, \
{"VisualData", "", icuVisualDataPosterXML}, \
{"VisualData", "Data", icuVisualDataDataPosterXML}};


/*****************************************
   MAIN PROGRAM
*****************************************/

void
webicu(FILE *f, int argc, char **argv, char **argn)
{
  int poster;
  
  fprintfBuf(f,
	  "HTTP/1.0 200 OK\nPragma: no-cache\n"
	  "Content-Type: text/plain\n\n");

  /* debut du xml */
  xmlHeader(f);
  xmlBalise("icu",BEGIN_BALISE_NEWLINE,f,0);
  xmlBalise("errorParam",BEGIN_BALISE,f,1);

  /* get parameters */
  poster = getPosterXML(f, argc, argv, argn, 9, tabPosterXML);

  fprintfBuf(f, "</errorParam>\n");

  if (poster == -2) {
    posterListXML(f, 9, tabPosterXML);
  }
  else if (poster != -1) {
    tabPosterXML[poster].posterXMLFunc(f);
  }

  xmlBalise("icu",TERMINATE_BALISE, f, 0);
  
}

/* ---------------- LE POSTER DE CONTROLE ------------------------------ */

static void 
icuActivitiesXML (FILE *f, ICU_CNTRL_STR *sdic)
{
#define ICU_NB_RQST_EXEC 29
#if ICU_NB_RQST_EXEC != 0

  
static char *icuExecRqstNameTab[] = {
"InitDisplay",
"CaptureImage",
"EnableDisplay",
"SetCameraPos",
"TrackIt",
"WaitForSomebody",
"WaitForSomeone",
"WaitForNobody",
"WaitForNone",
"WaitForNobodyKnown",
"WaitForPersonListChange",
"ProcessSetModality",
"FacerecSetWorkingPath",
"FacerecSetParams",
"FacerecInit",
"FacerecAddSomebody",
"FacerecSetPeople",
"FacerecRecognizeAll",
"FacerecLoadSomebody",
"FacerecUnloadSomebody",
"FacerecLoadEverybody",
"FacerecUnloadEverybody",
"WaitForModalityChange",
"LaunchPlatine",
"CmdPtu",
"IcuInitRFID",
"IcuCloseRFID",
"IcuAcquireRFID",
"IcuAcquireTag"
};
static int icuExecRqstNumTab[] = {
0, 4, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33};

  int i;
  ACTIVITY_EVENT evn;
  ACTIVITY_STATE status;
  int bilan;
  int rqst;
  char strerr[64];

  for (i=0; i<MAX_ACTIVITIES; i++) {
    status = M_ACTIVITY_STATUS(sdic,i);
    bilan = M_ACTIVITY_BILAN(sdic,i);

    if (status != ETHER || bilan != OK) {
      evn = M_ACTIVITY_EVN(sdic,i);
      
      xmlBalise("activity", BEGIN_BALISE_NEWLINE, f, 1);

      xmlBalise("id", BEGIN_BALISE, f, 2);
      fprintf(f, "%d", M_ACTIVITY_ID(sdic, i));
      xmlBalise("id", TERMINATE_BALISE, f, 0);
      
      /* find the name */
      rqst=0;
      while(icuExecRqstNumTab[rqst] != M_ACTIVITY_RQST_TYPE(sdic,i) 
	    && rqst<ICU_NB_RQST_EXEC)
	rqst++;
      xmlBalise("name", BEGIN_BALISE, f, 2);
      fprintf(f, "%s", 
	  rqst == ICU_NB_RQST_EXEC?
	  "Unknown" : icuExecRqstNameTab[rqst]);
      xmlBalise("name", TERMINATE_BALISE, f, 0);
      
      xmlBalise("task", BEGIN_BALISE, f, 2);
      fprintf(f, "%s", 
	  M_ACTIVITY_TASK_NUM(sdic,i) == -1 ? 
	  "not exec" : icuExecTaskNameTab[M_ACTIVITY_TASK_NUM(sdic,i)]);
      xmlBalise("task", TERMINATE_BALISE, f, 0);

      xmlBalise("status", BEGIN_BALISE, f, 2);
      fprintf(f, "%s", 
	  evn == NO_EVENT ?
	  h2GetEvnStateString(status) : h2GetEvnStateString(evn));
      xmlBalise("status", TERMINATE_BALISE, f, 0);
      
      xmlBalise("errno", BEGIN_BALISE, f, 2);
      fprintf(f, "%s", h2getErrMsg(bilan, strerr, 64));
      xmlBalise("errno", TERMINATE_BALISE, f, 0);

      xmlBalise("activity", TERMINATE_BALISE, f, 1);
    }

  }	/* for */

#endif /* ICU_NB_RQST_EXEC != 0 */
}

/* ----------------------------------------------------------------------
 *
 *  icuCntrlPosterXML - Affichage du poster de controle du module
 *
 */

STATUS icuCntrlPosterXML (FILE *f)
{
  ICU_CNTRL_STR *sdic;
  int i;
  char strerr[64];

  /* Read the control IDS */
  sdic = (ICU_CNTRL_STR *)malloc(sizeof(ICU_CNTRL_STR));
  if (sdic == NULL) {
    h2perror ("icuCntrlPosterXML");
    return ERROR;
  }
  if (icuCntrlPosterRead (sdic) != OK) {
    free(sdic);
    return ERROR;
  }

  /* 
   * display 
   */
  /* control task */
  xmlBalise("task", BEGIN_BALISE_NEWLINE, f, 1);

  xmlBalise("name", BEGIN_BALISE, f, 2);
  fprintf(f, "ControlTask");
  xmlBalise("name", TERMINATE_BALISE, f, 0);

  xmlBalise("status", BEGIN_BALISE, f, 2);
  fprintf(f, "%s", 
	  M_CNTRL_TASK_STATUS(sdic)==OK ? "OK":"ERROR");
  xmlBalise("status", TERMINATE_BALISE, f, 0);
  if (M_CNTRL_TASK_STATUS(sdic) != OK) {
    xmlBalise("errno", BEGIN_BALISE, f, 2);
    fprintf(f, "%s", h2getErrMsg(M_CNTRL_TASK_BILAN(sdic), strerr, 64));
    xmlBalise("errno", TERMINATE_BALISE, f, 0);
  }
  xmlBalise("task", TERMINATE_BALISE, f, 1);

  /* execution tasks */
  for (i=0; i<ICU_NB_EXEC_TASK; i++) {
    xmlBalise("task", BEGIN_BALISE_NEWLINE, f, 1);

    xmlBalise("name", BEGIN_BALISE, f, 2);
    fprintf(f, "%s", icuExecTaskNameTab[i]);
    xmlBalise("name", TERMINATE_BALISE, f, 0);

    xmlBalise("status", BEGIN_BALISE, f, 2);
    fprintf(f, "%s", M_EXEC_TASK_STATUS(sdic,i) == OK ? "OK": "ERROR");
    xmlBalise("status", TERMINATE_BALISE, f, 0);
    if (M_EXEC_TASK_STATUS(sdic, i) != OK) {
      xmlBalise("errno", BEGIN_BALISE, f, 2);
      fprintf(f, "%s", h2getErrMsg(M_EXEC_TASK_BILAN(sdic,i), strerr, 64));
      xmlBalise("errno", TERMINATE_BALISE, f, 0);
    }

    if (M_EXEC_TASK_PERIOD(sdic,i) != 0) {
      xmlBalise("period", BEGIN_BALISE, f, 2);
      fprintfBuf (f, "%d", (int)(M_EXEC_TASK_PERIOD(sdic,i)*1000.));
      xmlBalise("period", TERMINATE_BALISE, f, 0);
    }
    xmlBalise("task", TERMINATE_BALISE, f, 1);

  }

  /* Activities */
  icuActivitiesXML(f, sdic);

  free(sdic);
  return OK;
}

/**
 ** Dump only activities. XXX not used ? 
 **/
STATUS icuCntrlPosterActivityXML (FILE *f)
{
  ICU_CNTRL_STR *sdic;

  /* Lecture de la SDI de controle */
  sdic = (ICU_CNTRL_STR *)malloc(sizeof(ICU_CNTRL_STR));
  if (sdic == NULL) {
    h2perror ("icuCntrlPosterActivityXML");
    return ERROR;
  }
  if (icuCntrlPosterRead (sdic) != OK) {
    free(sdic);
    return ERROR;
  }
  icuActivitiesXML(f, sdic);
  free(sdic);
  return OK;
}

/* ---------------- LES POSTERS FONCTIONNELS ------------------------------ */

/* --  Results ------------------------------------------------- */

STATUS icuResultsPosterXML(FILE *f)
{
  BOOL err=FALSE;
  H2TIME posterDate;
  ICU_RESULTS_POSTER_STR x;

  xmlBalise("Results",BEGIN_BALISE_NEWLINE,f,1);
  xmlBalise("error",BEGIN_BALISE,f,2);

  if (icuResultsPosterRead(&x) == ERROR) {
    h2perror("icuResultsPosterXML");
    err=TRUE;
    fprintfBuf(f, "poster read failed");
  }
  fprintfBuf(f, "</error>\n");
  if (!err) {
    printXML_struct_ICU_RESULTS_POSTER_STR(f, "data", &x, 2, 0, NULL, NULL);
    posterIoctl(icuResultsPosterID(), FIO_GETDATE, &posterDate);
    xmlBalise("date",BEGIN_BALISE,f,2);
    fprintf(f, "%04d/%02d/%02d %02d:%02d:%02d.%03d",
             posterDate.year + 1900, posterDate.month,
             posterDate.date + 1, posterDate.hour,
             posterDate.minute, posterDate.sec,
             posterDate.msec);
    fprintf(f, "</date>\n");
  }
  xmlBalise("Results",TERMINATE_BALISE,f,1);
  return OK;
}

/* --  Results -> humanPos ---------------------------------------- */

STATUS icuResultshumanPosPosterXML(FILE *f)
{
  ICU_HUMAN_POS humanPos;
  int *dims = NULL;

  if (icuResultshumanPosPosterRead(&humanPos) == ERROR) {
     xmlBalise("ResultshumanPos",BEGIN_BALISE_NEWLINE,f,1);
     xmlBalise("error",BEGIN_BALISE,f,2);
     fprintfBuf(f, "icuResultshumanPosPosterXML: poster read failed");
     fprintfBuf(f, " </error>\n");
     xmlBalise("ResultshumanPos",TERMINATE_BALISE,f,1);
     h2perror("icuResultshumanPosPosterRead");
     return ERROR;
  }
  xmlBalise("ResultshumanPos",BEGIN_BALISE_NEWLINE,f,1);
  xmlBalise("error",BEGIN_BALISE,f,2);
  fprintfBuf(f, " </error>\n");
  printXML_struct_ICU_HUMAN_POS(f, "data", &humanPos, 2, 0, dims, NULL);
  xmlBalise("ResultshumanPos",TERMINATE_BALISE,f,1);
  return OK;
}

/* --  HumanPresence ------------------------------------------------- */

STATUS icuHumanPresencePosterXML(FILE *f)
{
  BOOL err=FALSE;
  H2TIME posterDate;
  ICU_HUMANPRESENCE_POSTER_STR x;

  xmlBalise("HumanPresence",BEGIN_BALISE_NEWLINE,f,1);
  xmlBalise("error",BEGIN_BALISE,f,2);

  if (icuHumanPresencePosterRead(&x) == ERROR) {
    h2perror("icuHumanPresencePosterXML");
    err=TRUE;
    fprintfBuf(f, "poster read failed");
  }
  fprintfBuf(f, "</error>\n");
  if (!err) {
    printXML_struct_ICU_HUMANPRESENCE_POSTER_STR(f, "data", &x, 2, 0, NULL, NULL);
    posterIoctl(icuHumanPresencePosterID(), FIO_GETDATE, &posterDate);
    xmlBalise("date",BEGIN_BALISE,f,2);
    fprintf(f, "%04d/%02d/%02d %02d:%02d:%02d.%03d",
             posterDate.year + 1900, posterDate.month,
             posterDate.date + 1, posterDate.hour,
             posterDate.minute, posterDate.sec,
             posterDate.msec);
    fprintf(f, "</date>\n");
  }
  xmlBalise("HumanPresence",TERMINATE_BALISE,f,1);
  return OK;
}

/* --  HumanPresence -> loadedPersonList ---------------------------------------- */

STATUS icuHumanPresenceloadedPersonListPosterXML(FILE *f)
{
  ICU_RECOGNITION_WHOLIST loadedPersonList;
  int *dims = NULL;

  if (icuHumanPresenceloadedPersonListPosterRead(&loadedPersonList) == ERROR) {
     xmlBalise("HumanPresenceloadedPersonList",BEGIN_BALISE_NEWLINE,f,1);
     xmlBalise("error",BEGIN_BALISE,f,2);
     fprintfBuf(f, "icuHumanPresenceloadedPersonListPosterXML: poster read failed");
     fprintfBuf(f, " </error>\n");
     xmlBalise("HumanPresenceloadedPersonList",TERMINATE_BALISE,f,1);
     h2perror("icuHumanPresenceloadedPersonListPosterRead");
     return ERROR;
  }
  xmlBalise("HumanPresenceloadedPersonList",BEGIN_BALISE_NEWLINE,f,1);
  xmlBalise("error",BEGIN_BALISE,f,2);
  fprintfBuf(f, " </error>\n");
  printXML_struct_ICU_RECOGNITION_WHOLIST(f, "data", &loadedPersonList, 2, 0, dims, NULL);
  xmlBalise("HumanPresenceloadedPersonList",TERMINATE_BALISE,f,1);
  return OK;
}

/* --  PlatineCmd ------------------------------------------------- */

STATUS icuPlatineCmdPosterXML(FILE *f)
{
  BOOL err=FALSE;
  H2TIME posterDate;
  ICU_PLATINECMD_POSTER_STR x;

  xmlBalise("PlatineCmd",BEGIN_BALISE_NEWLINE,f,1);
  xmlBalise("error",BEGIN_BALISE,f,2);

  if (icuPlatineCmdPosterRead(&x) == ERROR) {
    h2perror("icuPlatineCmdPosterXML");
    err=TRUE;
    fprintfBuf(f, "poster read failed");
  }
  fprintfBuf(f, "</error>\n");
  if (!err) {
    printXML_struct_ICU_PLATINECMD_POSTER_STR(f, "data", &x, 2, 0, NULL, NULL);
    posterIoctl(icuPlatineCmdPosterID(), FIO_GETDATE, &posterDate);
    xmlBalise("date",BEGIN_BALISE,f,2);
    fprintf(f, "%04d/%02d/%02d %02d:%02d:%02d.%03d",
             posterDate.year + 1900, posterDate.month,
             posterDate.date + 1, posterDate.hour,
             posterDate.minute, posterDate.sec,
             posterDate.msec);
    fprintf(f, "</date>\n");
  }
  xmlBalise("PlatineCmd",TERMINATE_BALISE,f,1);
  return OK;
}

/* --  PlatineCmd -> cmdPlatine ---------------------------------------- */

STATUS icuPlatineCmdcmdPlatinePosterXML(FILE *f)
{
  PLATINE_AXIS_STR cmdPlatine;
  int *dims = NULL;

  if (icuPlatineCmdcmdPlatinePosterRead(&cmdPlatine) == ERROR) {
     xmlBalise("PlatineCmdcmdPlatine",BEGIN_BALISE_NEWLINE,f,1);
     xmlBalise("error",BEGIN_BALISE,f,2);
     fprintfBuf(f, "icuPlatineCmdcmdPlatinePosterXML: poster read failed");
     fprintfBuf(f, " </error>\n");
     xmlBalise("PlatineCmdcmdPlatine",TERMINATE_BALISE,f,1);
     h2perror("icuPlatineCmdcmdPlatinePosterRead");
     return ERROR;
  }
  xmlBalise("PlatineCmdcmdPlatine",BEGIN_BALISE_NEWLINE,f,1);
  xmlBalise("error",BEGIN_BALISE,f,2);
  fprintfBuf(f, " </error>\n");
  printXML_struct_PLATINE_AXIS_STR(f, "data", &cmdPlatine, 2, 0, dims, NULL);
  xmlBalise("PlatineCmdcmdPlatine",TERMINATE_BALISE,f,1);
  return OK;
}

/* --  VisualData ------------------------------------------------- */

STATUS icuVisualDataPosterXML(FILE *f)
{
  BOOL err=FALSE;
  H2TIME posterDate;
  ICU_VISUALDATA_POSTER_STR x;

  xmlBalise("VisualData",BEGIN_BALISE_NEWLINE,f,1);
  xmlBalise("error",BEGIN_BALISE,f,2);

  if (icuVisualDataPosterRead(&x) == ERROR) {
    h2perror("icuVisualDataPosterXML");
    err=TRUE;
    fprintfBuf(f, "poster read failed");
  }
  fprintfBuf(f, "</error>\n");
  if (!err) {
    printXML_struct_ICU_VISUALDATA_POSTER_STR(f, "data", &x, 2, 0, NULL, NULL);
    posterIoctl(icuVisualDataPosterID(), FIO_GETDATE, &posterDate);
    xmlBalise("date",BEGIN_BALISE,f,2);
    fprintf(f, "%04d/%02d/%02d %02d:%02d:%02d.%03d",
             posterDate.year + 1900, posterDate.month,
             posterDate.date + 1, posterDate.hour,
             posterDate.minute, posterDate.sec,
             posterDate.msec);
    fprintf(f, "</date>\n");
  }
  xmlBalise("VisualData",TERMINATE_BALISE,f,1);
  return OK;
}

/* --  VisualData -> Data ---------------------------------------- */

STATUS icuVisualDataDataPosterXML(FILE *f)
{
  ICU_VISUAL_DATA Data;
  int *dims = NULL;

  if (icuVisualDataDataPosterRead(&Data) == ERROR) {
     xmlBalise("VisualDataData",BEGIN_BALISE_NEWLINE,f,1);
     xmlBalise("error",BEGIN_BALISE,f,2);
     fprintfBuf(f, "icuVisualDataDataPosterXML: poster read failed");
     fprintfBuf(f, " </error>\n");
     xmlBalise("VisualDataData",TERMINATE_BALISE,f,1);
     h2perror("icuVisualDataDataPosterRead");
     return ERROR;
  }
  xmlBalise("VisualDataData",BEGIN_BALISE_NEWLINE,f,1);
  xmlBalise("error",BEGIN_BALISE,f,2);
  fprintfBuf(f, " </error>\n");
  printXML_struct_ICU_VISUAL_DATA(f, "data", &Data, 2, 0, dims, NULL);
  xmlBalise("VisualDataData",TERMINATE_BALISE,f,1);
  return OK;
}


