
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef ICU_PRINT_H
#define ICU_PRINT_H

#include "genom/printScan.h"

/* Structures definies par d'autres modules */

#include "server/rfidPrint.h"

#include "server/platinePrint.h"

#include "server/viamPrint.h"

#include "server/pomPrint.h"

#include "server/genBasicPrint.h"


#include "icuPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
extern void print_struct_ICU_VISUALDATA_POSTER_STR ( FILE *out,
     struct ICU_VISUALDATA_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_PLATINECMD_POSTER_STR ( FILE *out,
     struct ICU_PLATINECMD_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_HUMANPRESENCE_POSTER_STR ( FILE *out,
     struct ICU_HUMANPRESENCE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_RESULTS_POSTER_STR ( FILE *out,
     struct ICU_RESULTS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_STR ( FILE *out,
     struct ICU_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_VISUAL_DATA ( FILE *out,
     struct ICU_VISUAL_DATA *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_PLATINE_PARAMS ( FILE *out,
     struct ICU_PLATINE_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_PERSON_LIST_PARAMS ( FILE *out,
     struct ICU_PERSON_LIST_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_TRACKING_VALUES ( FILE *out,
     struct ICU_TRACKING_VALUES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_RFID_TAG ( FILE *out,
     struct ICU_RFID_TAG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_RECOGNITION_WHOLIST ( FILE *out,
     struct ICU_RECOGNITION_WHOLIST *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_RECOGNITION_WHO ( FILE *out,
     struct ICU_RECOGNITION_WHO *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_RECOGNITION_VALUE ( FILE *out,
     struct ICU_RECOGNITION_VALUE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_TRACKING_FACE_ROI ( FILE *out,
     struct ICU_TRACKING_FACE_ROI *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_TRACKING_STATE_VECTOR ( FILE *out,
     struct ICU_TRACKING_STATE_VECTOR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_AUTOSWITCH_CONTROL ( FILE *out,
     struct ICU_AUTOSWITCH_CONTROL *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_CAMERA_POS ( FILE *out,
     struct ICU_CAMERA_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_PAN_TILT_LIMITS ( FILE *out,
     struct ICU_PAN_TILT_LIMITS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_AFFICHAGE ( FILE *out,
     struct ICU_AFFICHAGE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_HUMAN_POS ( FILE *out,
     struct ICU_HUMAN_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_PERSON_POS ( FILE *out,
     struct ICU_PERSON_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_ICU_WAITFOR ( FILE *out,
     struct ICU_WAITFOR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_str ( FILE *out,
     struct str *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_ICU_MODALITIES ( FILE *out,
     enum ICU_MODALITIES *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void print_ICU_MODALITIES ( FILE *out,
     ICU_MODALITIES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_str ( FILE *out,
     str *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_WAITFOR ( FILE *out,
     ICU_WAITFOR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_PERSON_POS ( FILE *out,
     ICU_PERSON_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_HUMAN_POS ( FILE *out,
     ICU_HUMAN_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_AFFICHAGE ( FILE *out,
     ICU_AFFICHAGE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_PAN_TILT_LIMITS ( FILE *out,
     ICU_PAN_TILT_LIMITS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_CAMERA_POS ( FILE *out,
     ICU_CAMERA_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_AUTOSWITCH_CONTROL ( FILE *out,
     ICU_AUTOSWITCH_CONTROL *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_TRACKING_STATE_VECTOR ( FILE *out,
     ICU_TRACKING_STATE_VECTOR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_TRACKING_FACE_ROI ( FILE *out,
     ICU_TRACKING_FACE_ROI *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_RECOGNITION_VALUE ( FILE *out,
     ICU_RECOGNITION_VALUE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_RECOGNITION_WHO ( FILE *out,
     ICU_RECOGNITION_WHO *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_RECOGNITION_WHOLIST ( FILE *out,
     ICU_RECOGNITION_WHOLIST *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_RFID_TAG ( FILE *out,
     ICU_RFID_TAG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_TRACKING_VALUES ( FILE *out,
     ICU_TRACKING_VALUES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_PERSON_LIST_PARAMS ( FILE *out,
     ICU_PERSON_LIST_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_PLATINE_PARAMS ( FILE *out,
     ICU_PLATINE_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_VISUAL_DATA ( FILE *out,
     ICU_VISUAL_DATA *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_STR ( FILE *out,
     ICU_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_RESULTS_POSTER_STR ( FILE *out,
     ICU_RESULTS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_HUMANPRESENCE_POSTER_STR ( FILE *out,
     ICU_HUMANPRESENCE_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_PLATINECMD_POSTER_STR ( FILE *out,
     ICU_PLATINECMD_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_ICU_VISUALDATA_POSTER_STR ( FILE *out,
     ICU_VISUALDATA_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
#ifdef __cplusplus
}
#endif

#endif /* ICU_PRINT_H */

