
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

/* 
 * icuType.h:     La SDI_F de icu
 *
 * Utilise par le module et par les clients
 * (inclut dans icuMsgLib.h et icuPosterLib.h)
 * 
 */

#ifndef icu_TYPE_H
#define icu_TYPE_H

#include "genom/modules.h"
#include "icuError.h"

/* Nombre de tache d'execution de ce module */
#define ICU_NB_EXEC_TASK                   (1)


#endif
#ifndef icu_TYPE1_H
#define icu_TYPE1_H

#include "/home/aamekonn/openrobots/include/genBasic/genBasicStruct.h"
#include "/home/aamekonn/openrobots/include/pom/pomStruct.h"
#include "/home/aamekonn/openrobots/include/viam/viamtypes.h"
#include "/home/aamekonn/openrobots/include/viam/viamStruct.h"
#include "/home/aamekonn/openrobots/include/platine/platineStruct.h"
#include "/home/aamekonn/openrobots/include/rfid/rfidStruct.h"
#include "icuStruct.h"

/*
 * Structure de donnees interne
 */
typedef struct ICU_STR {
	str viamPosterName;
	ICU_MODALITIES setModality;
	int tag_on_off;
	POM_EULER_V exportPomSE;
	int currentModality;
	ICU_AFFICHAGE display;
	int displayHRDistance;
	int track_it;
	int save_face;
	ICU_HUMAN_POS humanPos;
	ICU_PAN_TILT_LIMITS limits;
	ICU_TRACKING_VALUES results;
	ICU_VISUAL_DATA Data;
	ICU_AUTOSWITCH_CONTROL autoSwitchControl;
	int nbImageMaxNobody;
	int cameraMove;
	ICU_CAMERA_POS cameraPos;
	int captureImage;
	int captureVideo;
	int pictureNumber;
	GEN_STRING256 recoName;
	GEN_STRING256 recoTag;
	GEN_STRING256 recoAddName;
	int recoId;
	int recoAddSomebody;
	ICU_WAITFOR waitFor;
	int waitForNameIsSet;
	int waitForId;
	ICU_RECOGNITION_WHOLIST knownPersonList;
	ICU_RECOGNITION_WHOLIST loadedPersonList;
	int personListChanged;
	ICU_PERSON_LIST_PARAMS paramsPersonList;
	GEN_STRING256 facerecWorkingPath;
	PLATINE_AXIS_STR cmdPlatine;
	ICU_PLATINE_PARAMS platineParams;
	int CaptureImageInput[20];
	ICU_CAMERA_POS SetCameraPosInput[20];
	int TrackItInput[20];
	int WaitForSomebodyInput[20];
	ICU_WAITFOR WaitForSomebodyOutput[20];
	ICU_WAITFOR WaitForSomeoneInput[20];
	int WaitForNobodyInput[20];
	ICU_WAITFOR WaitForNoneInput[20];
	int WaitForNobodyKnownInput[20];
} ICU_STR;


#endif

