
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] icuInstall] >= 0 } {
    interp expose {} icuInstall
}

proc ::icuInstall { name } {
    foreach rqst { "InitDisplay" "PomTagging" "AutoMode" "SaveFace" "CaptureImage" "CaptureVideo" "SetViamPosterName" "EnableDisplay" "SetCameraPos" "TrackIt" "WaitForSomebody" "WaitForSomeone" "WaitForNobody" "WaitForNone" "WaitForNobodyKnown" "WaitForPersonListChange" "ProcessSetModality" "FacerecSetWorkingPath" "FacerecSetParams" "FacerecInit" "FacerecAddSomebody" "FacerecSetPeople" "FacerecRecognizeAll" "FacerecLoadSomebody" "FacerecUnloadSomebody" "FacerecLoadEverybody" "FacerecUnloadEverybody" "WaitForModalityChange" "LaunchPlatine" "CmdPtu" "IcuInitRFID" "IcuCloseRFID" "IcuAcquireRFID" "IcuAcquireTag" "ResultshumanPosPosterRead" "HumanPresenceloadedPersonListPosterRead" "PlatineCmdcmdPlatinePosterRead" "VisualDataDataPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} icu$rqst $name
    }
}

interp hide {} icuInstall




# InitDisplay ----------------------------------------------------------

if { [lsearch [interp hidden] icuInitDisplay] >= 0 } {
    interp expose {} icuInitDisplay
}
if { [lsearch [interp hidden] icuInitDisplayFormatOutput] >= 0 } {
    interp expose {} icuInitDisplayFormatOutput
}

proc ::icuInitDisplay { name args } {
    set format {}
    lappend format [list int "display enable" 1 ]
    lappend format [list int "width" 320 ]
    lappend format [list int "height" 240 ]
    lappend format [list int "horizontal position" 0 ]
    lappend format [list int "vertical position" 0 ]
    lappend format [list int "display.unused" 0 ]

    return [ ::cs::rqstSend "${name}" "InitDisplay" \
	"This request is used to init the display size and position, the video stream and the camera link." \
	"ICU_AFFICHAGE\n| int display\n| int width\n| int height\n| int posx\n| int posy\n| int unused\n" \
	6 \
	$format \
	$args ]
}


proc ::icuInitDisplayFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuInitDisplay
interp hide {} icuInitDisplayFormatOutput





# PomTagging ----------------------------------------------------------

if { [lsearch [interp hidden] icuPomTagging] >= 0 } {
    interp expose {} icuPomTagging
}
if { [lsearch [interp hidden] icuPomTaggingFormatOutput] >= 0 } {
    interp expose {} icuPomTaggingFormatOutput
}

proc ::icuPomTagging { name args } {
    set format {}
    lappend format [list int "tagging mode disable" 0 ]

    return [ ::cs::rqstSend "${name}" "PomTagging" \
	"this request is used to set or not the tag on the data" \
	"int tag_on_off\n" \
	1 \
	$format \
	$args ]
}


proc ::icuPomTaggingFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuPomTagging
interp hide {} icuPomTaggingFormatOutput





# AutoMode ----------------------------------------------------------

if { [lsearch [interp hidden] icuAutoMode] >= 0 } {
    interp expose {} icuAutoMode
}
if { [lsearch [interp hidden] icuAutoModeFormatOutput] >= 0 } {
    interp expose {} icuAutoModeFormatOutput
}

proc ::icuAutoMode { name args } {
    set format {}
    lappend format [list int "autoSwitchControl.autoSwitchMode" 0 ]
    lappend format [list int "autoSwitchControl.isRobotMoving" 0 ]

    return [ ::cs::rqstSend "${name}" "AutoMode" \
	"1 if you want automatic switch 0 else" \
	"ICU_AUTOSWITCH_CONTROL\n| int autoSwitchMode\n| int isRobotMoving\n" \
	2 \
	$format \
	$args ]
}


proc ::icuAutoModeFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuAutoMode
interp hide {} icuAutoModeFormatOutput





# SaveFace ----------------------------------------------------------

if { [lsearch [interp hidden] icuSaveFace] >= 0 } {
    interp expose {} icuSaveFace
}
if { [lsearch [interp hidden] icuSaveFaceFormatOutput] >= 0 } {
    interp expose {} icuSaveFaceFormatOutput
}

proc ::icuSaveFace { name args } {
    set format {}
    lappend format [list int "no face saved" 0 ]

    return [ ::cs::rqstSend "${name}" "SaveFace" \
	"1 if you want to save face 0 else" \
	"int save_face\n" \
	1 \
	$format \
	$args ]
}


proc ::icuSaveFaceFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuSaveFace
interp hide {} icuSaveFaceFormatOutput





# CaptureImage ----------------------------------------------------------

if { [lsearch [interp hidden] icuCaptureImage] >= 0 } {
    interp expose {} icuCaptureImage
}
if { [lsearch [interp hidden] icuCaptureImageFormatOutput] >= 0 } {
    interp expose {} icuCaptureImageFormatOutput
}

proc ::icuCaptureImage { name args } {
    set format {}
    lappend format [list int "no capture enabled" 0 ]

    return [ ::cs::rqstSend "${name}" "CaptureImage" \
	"1 if you want to save a picture 0 else" \
	"int captureImage\n" \
	1 \
	$format \
	$args ]
}


proc ::icuCaptureImageFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuCaptureImage
interp hide {} icuCaptureImageFormatOutput





# CaptureVideo ----------------------------------------------------------

if { [lsearch [interp hidden] icuCaptureVideo] >= 0 } {
    interp expose {} icuCaptureVideo
}
if { [lsearch [interp hidden] icuCaptureVideoFormatOutput] >= 0 } {
    interp expose {} icuCaptureVideoFormatOutput
}

proc ::icuCaptureVideo { name args } {
    set format {}
    lappend format [list int "no capture enabled" 0 ]

    return [ ::cs::rqstSend "${name}" "CaptureVideo" \
	"1 if you want to save stream 0 to stop saving" \
	"int captureVideo\n" \
	1 \
	$format \
	$args ]
}


proc ::icuCaptureVideoFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuCaptureVideo
interp hide {} icuCaptureVideoFormatOutput





# SetViamPosterName ----------------------------------------------------------

if { [lsearch [interp hidden] icuSetViamPosterName] >= 0 } {
    interp expose {} icuSetViamPosterName
}
if { [lsearch [interp hidden] icuSetViamPosterNameFormatOutput] >= 0 } {
    interp expose {} icuSetViamPosterNameFormatOutput
}

proc ::icuSetViamPosterName { name args } {
    set format {}
    lappend format [list string "Defaul viam image poster name" "" ]

    return [ ::cs::rqstSend "${name}" "SetViamPosterName" \
	"The name of viam poster" \
	"str\n| char name\[255\]\n" \
	1 \
	$format \
	$args ]
}


proc ::icuSetViamPosterNameFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuSetViamPosterName
interp hide {} icuSetViamPosterNameFormatOutput





# EnableDisplay ----------------------------------------------------------

if { [lsearch [interp hidden] icuEnableDisplay] >= 0 } {
    interp expose {} icuEnableDisplay
}
if { [lsearch [interp hidden] icuEnableDisplayFormatOutput] >= 0 } {
    interp expose {} icuEnableDisplayFormatOutput
}

proc ::icuEnableDisplay { name args } {
    set format {}
    lappend format [list int "display enable" 1 ]
    lappend format [list int "width" 320 ]
    lappend format [list int "height" 240 ]
    lappend format [list int "horizontal position" 0 ]
    lappend format [list int "vertical position" 0 ]
    lappend format [list int "display.unused" 0 ]

    return [ ::cs::rqstSend "${name}" "EnableDisplay" \
	"1 if you want to display stream 0 to stop displaying" \
	"ICU_AFFICHAGE\n| int display\n| int width\n| int height\n| int posx\n| int posy\n| int unused\n" \
	6 \
	$format \
	$args ]
}


proc ::icuEnableDisplayFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuEnableDisplay
interp hide {} icuEnableDisplayFormatOutput





# SetCameraPos ----------------------------------------------------------

if { [lsearch [interp hidden] icuSetCameraPos] >= 0 } {
    interp expose {} icuSetCameraPos
}
if { [lsearch [interp hidden] icuSetCameraPosFormatOutput] >= 0 } {
    interp expose {} icuSetCameraPosFormatOutput
}

proc ::icuSetCameraPos { name args } {
    set format {}
    lappend format [list float "cameraPos.pan" 0.0 ]
    lappend format [list float "cameraPos.tilt" 0.0 ]
    lappend format [list float "cameraPos.zoom" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetCameraPos" \
	"The position you want the camera to go to" \
	"ICU_CAMERA_POS\n| float pan\n| float tilt\n| float zoom\n" \
	3 \
	$format \
	$args ]
}


proc ::icuSetCameraPosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuSetCameraPos
interp hide {} icuSetCameraPosFormatOutput





# TrackIt ----------------------------------------------------------

if { [lsearch [interp hidden] icuTrackIt] >= 0 } {
    interp expose {} icuTrackIt
}
if { [lsearch [interp hidden] icuTrackItFormatOutput] >= 0 } {
    interp expose {} icuTrackItFormatOutput
}

proc ::icuTrackIt { name args } {
    set format {}
    lappend format [list int "tracking disable" 1 ]

    return [ ::cs::rqstSend "${name}" "TrackIt" \
	" this request is used to enable the mouvement of the camera to follow people" \
	"int track_it\n" \
	1 \
	$format \
	$args ]
}


proc ::icuTrackItFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuTrackIt
interp hide {} icuTrackItFormatOutput





# WaitForSomebody ----------------------------------------------------------

if { [lsearch [interp hidden] icuWaitForSomebody] >= 0 } {
    interp expose {} icuWaitForSomebody
}
if { [lsearch [interp hidden] icuWaitForSomebodyFormatOutput] >= 0 } {
    interp expose {} icuWaitForSomebodyFormatOutput
}

proc ::icuWaitForSomebody { name args } {
    set format {}
    lappend format [list int "nbImageMaxNobody" 0 ]

    return [ ::cs::rqstSend "${name}" "WaitForSomebody" \
	"Wait for somebody before the cam" \
	"int nbImageMaxNobody\n" \
	1 \
	$format \
	$args ]
}


proc ::icuWaitForSomebodyFormatOutput { list } {
    set format { {} status { } { waitFor { } name { } nbImageMinSomebody } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuWaitForSomebody
interp hide {} icuWaitForSomebodyFormatOutput





# WaitForSomeone ----------------------------------------------------------

if { [lsearch [interp hidden] icuWaitForSomeone] >= 0 } {
    interp expose {} icuWaitForSomeone
}
if { [lsearch [interp hidden] icuWaitForSomeoneFormatOutput] >= 0 } {
    interp expose {} icuWaitForSomeoneFormatOutput
}

proc ::icuWaitForSomeone { name args } {
    set format {}
    lappend format [list string "waitFor.name" "" ]
    lappend format [list int "waitFor.nbImageMinSomebody" 0 ]

    return [ ::cs::rqstSend "${name}" "WaitForSomeone" \
	"Wait for somebody before the cam" \
	"ICU_WAITFOR\n| char name\[256\]\n| int nbImageMinSomebody\n" \
	2 \
	$format \
	$args ]
}


proc ::icuWaitForSomeoneFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuWaitForSomeone
interp hide {} icuWaitForSomeoneFormatOutput





# WaitForNobody ----------------------------------------------------------

if { [lsearch [interp hidden] icuWaitForNobody] >= 0 } {
    interp expose {} icuWaitForNobody
}
if { [lsearch [interp hidden] icuWaitForNobodyFormatOutput] >= 0 } {
    interp expose {} icuWaitForNobodyFormatOutput
}

proc ::icuWaitForNobody { name args } {
    set format {}
    lappend format [list int "nbImageMaxNobody" 0 ]

    return [ ::cs::rqstSend "${name}" "WaitForNobody" \
	"Wait for nobody before the cam" \
	"int nbImageMaxNobody\n" \
	1 \
	$format \
	$args ]
}


proc ::icuWaitForNobodyFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuWaitForNobody
interp hide {} icuWaitForNobodyFormatOutput





# WaitForNone ----------------------------------------------------------

if { [lsearch [interp hidden] icuWaitForNone] >= 0 } {
    interp expose {} icuWaitForNone
}
if { [lsearch [interp hidden] icuWaitForNoneFormatOutput] >= 0 } {
    interp expose {} icuWaitForNoneFormatOutput
}

proc ::icuWaitForNone { name args } {
    set format {}
    lappend format [list string "waitFor.name" "" ]
    lappend format [list int "waitFor.nbImageMinSomebody" 0 ]

    return [ ::cs::rqstSend "${name}" "WaitForNone" \
	"Wait for nobody before the cam" \
	"ICU_WAITFOR\n| char name\[256\]\n| int nbImageMinSomebody\n" \
	2 \
	$format \
	$args ]
}


proc ::icuWaitForNoneFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuWaitForNone
interp hide {} icuWaitForNoneFormatOutput





# WaitForNobodyKnown ----------------------------------------------------------

if { [lsearch [interp hidden] icuWaitForNobodyKnown] >= 0 } {
    interp expose {} icuWaitForNobodyKnown
}
if { [lsearch [interp hidden] icuWaitForNobodyKnownFormatOutput] >= 0 } {
    interp expose {} icuWaitForNobodyKnownFormatOutput
}

proc ::icuWaitForNobodyKnown { name args } {
    set format {}
    lappend format [list int "nbImageMaxNobody" 0 ]

    return [ ::cs::rqstSend "${name}" "WaitForNobodyKnown" \
	"Wait for nobody before the cam" \
	"int nbImageMaxNobody\n" \
	1 \
	$format \
	$args ]
}


proc ::icuWaitForNobodyKnownFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuWaitForNobodyKnown
interp hide {} icuWaitForNobodyKnownFormatOutput





# WaitForPersonListChange ----------------------------------------------------------

if { [lsearch [interp hidden] icuWaitForPersonListChange] >= 0 } {
    interp expose {} icuWaitForPersonListChange
}
if { [lsearch [interp hidden] icuWaitForPersonListChangeFormatOutput] >= 0 } {
    interp expose {} icuWaitForPersonListChangeFormatOutput
}

proc ::icuWaitForPersonListChange { name args } {
    set format {}
    lappend format [list double "seuilReco" 0.500000 ]
    lappend format [list int "absenceWindow" 20 ]
    lappend format [list int "presenceWindow" 20 ]
    lappend format [list double "absenceRatio" 0.800000 ]
    lappend format [list double "presenceRatio" 0.300000 ]

    return [ ::cs::rqstSend "${name}" "WaitForPersonListChange" \
	"Wait for change in the person lis tab" \
	"ICU_PERSON_LIST_PARAMS\n| double seuilReco\n| int absenceWindow\n| int presenceWindow\n| double absenceRatio\n| double presenceRatio\n" \
	5 \
	$format \
	$args ]
}


proc ::icuWaitForPersonListChangeFormatOutput { list } {
    set format { {} status { } { waitFor { } name { } nbImageMinSomebody } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuWaitForPersonListChange
interp hide {} icuWaitForPersonListChangeFormatOutput





# ProcessSetModality ----------------------------------------------------------

if { [lsearch [interp hidden] icuProcessSetModality] >= 0 } {
    interp expose {} icuProcessSetModality
}
if { [lsearch [interp hidden] icuProcessSetModalityFormatOutput] >= 0 } {
    interp expose {} icuProcessSetModalityFormatOutput
}

proc ::icuProcessSetModality { name args } {
    set format {}
    lappend format [list { "ICU_NB_MODALITY_MAX" "ICU_FACE_RECOGNITION" "ICU_MOTION_MONITORING" "ICU_BODY_TRACKING" "ICU_FACE_TRACKING" "ICU_MOTION_DETECTION" "ICU_FACE_DETECTION" "ICU_AUTO_SWITCH_MODE" "ICU_NO_PROCESS" } "setModality" "" ]

    return [ ::cs::rqstSend "${name}" "ProcessSetModality" \
	"Switch ICU to modality" \
	"ICU_MODALITIES setModality\n" \
	1 \
	$format \
	$args ]
}


proc ::icuProcessSetModalityFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuProcessSetModality
interp hide {} icuProcessSetModalityFormatOutput





# FacerecSetWorkingPath ----------------------------------------------------------

if { [lsearch [interp hidden] icuFacerecSetWorkingPath] >= 0 } {
    interp expose {} icuFacerecSetWorkingPath
}
if { [lsearch [interp hidden] icuFacerecSetWorkingPathFormatOutput] >= 0 } {
    interp expose {} icuFacerecSetWorkingPathFormatOutput
}

proc ::icuFacerecSetWorkingPath { name args } {
    set format {}
    lappend format [list string "facerecWorkingPath.name" "" ]

    return [ ::cs::rqstSend "${name}" "FacerecSetWorkingPath" \
	"Set facerec database path" \
	"GEN_STRING256\n| char name\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::icuFacerecSetWorkingPathFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuFacerecSetWorkingPath
interp hide {} icuFacerecSetWorkingPathFormatOutput





# FacerecSetParams ----------------------------------------------------------

if { [lsearch [interp hidden] icuFacerecSetParams] >= 0 } {
    interp expose {} icuFacerecSetParams
}
if { [lsearch [interp hidden] icuFacerecSetParamsFormatOutput] >= 0 } {
    interp expose {} icuFacerecSetParamsFormatOutput
}

proc ::icuFacerecSetParams { name args } {
    set format {}
    lappend format [list double "paramsPersonList.seuilReco" 0.0 ]
    lappend format [list int "paramsPersonList.absenceWindow" 0 ]
    lappend format [list int "paramsPersonList.presenceWindow" 0 ]
    lappend format [list double "paramsPersonList.absenceRatio" 0.0 ]
    lappend format [list double "paramsPersonList.presenceRatio" 0.0 ]

    return [ ::cs::rqstSend "${name}" "FacerecSetParams" \
	"Set facerec personList parameters" \
	"ICU_PERSON_LIST_PARAMS\n| double seuilReco\n| int absenceWindow\n| int presenceWindow\n| double absenceRatio\n| double presenceRatio\n" \
	5 \
	$format \
	$args ]
}


proc ::icuFacerecSetParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuFacerecSetParams
interp hide {} icuFacerecSetParamsFormatOutput





# FacerecInit ----------------------------------------------------------

if { [lsearch [interp hidden] icuFacerecInit] >= 0 } {
    interp expose {} icuFacerecInit
}
if { [lsearch [interp hidden] icuFacerecInitFormatOutput] >= 0 } {
    interp expose {} icuFacerecInitFormatOutput
}

proc ::icuFacerecInit { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "FacerecInit" \
	"Initialise the classifier with loaded bases" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::icuFacerecInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuFacerecInit
interp hide {} icuFacerecInitFormatOutput





# FacerecAddSomebody ----------------------------------------------------------

if { [lsearch [interp hidden] icuFacerecAddSomebody] >= 0 } {
    interp expose {} icuFacerecAddSomebody
}
if { [lsearch [interp hidden] icuFacerecAddSomebodyFormatOutput] >= 0 } {
    interp expose {} icuFacerecAddSomebodyFormatOutput
}

proc ::icuFacerecAddSomebody { name args } {
    set format {}
    lappend format [list string "recoAddName.name" "" ]

    return [ ::cs::rqstSend "${name}" "FacerecAddSomebody" \
	"Add somebody to the specified base" \
	"GEN_STRING256\n| char name\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::icuFacerecAddSomebodyFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuFacerecAddSomebody
interp hide {} icuFacerecAddSomebodyFormatOutput





# FacerecSetPeople ----------------------------------------------------------

if { [lsearch [interp hidden] icuFacerecSetPeople] >= 0 } {
    interp expose {} icuFacerecSetPeople
}
if { [lsearch [interp hidden] icuFacerecSetPeopleFormatOutput] >= 0 } {
    interp expose {} icuFacerecSetPeopleFormatOutput
}

proc ::icuFacerecSetPeople { name args } {
    set format {}
    lappend format [list string "recoName.name" "" ]

    return [ ::cs::rqstSend "${name}" "FacerecSetPeople" \
	"Set the people to recognize" \
	"GEN_STRING256\n| char name\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::icuFacerecSetPeopleFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuFacerecSetPeople
interp hide {} icuFacerecSetPeopleFormatOutput





# FacerecRecognizeAll ----------------------------------------------------------

if { [lsearch [interp hidden] icuFacerecRecognizeAll] >= 0 } {
    interp expose {} icuFacerecRecognizeAll
}
if { [lsearch [interp hidden] icuFacerecRecognizeAllFormatOutput] >= 0 } {
    interp expose {} icuFacerecRecognizeAllFormatOutput
}

proc ::icuFacerecRecognizeAll { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "FacerecRecognizeAll" \
	"Set the recognition to all the people" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::icuFacerecRecognizeAllFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuFacerecRecognizeAll
interp hide {} icuFacerecRecognizeAllFormatOutput





# FacerecLoadSomebody ----------------------------------------------------------

if { [lsearch [interp hidden] icuFacerecLoadSomebody] >= 0 } {
    interp expose {} icuFacerecLoadSomebody
}
if { [lsearch [interp hidden] icuFacerecLoadSomebodyFormatOutput] >= 0 } {
    interp expose {} icuFacerecLoadSomebodyFormatOutput
}

proc ::icuFacerecLoadSomebody { name args } {
    set format {}
    lappend format [list string "recoName.name" "" ]

    return [ ::cs::rqstSend "${name}" "FacerecLoadSomebody" \
	"Request to load somebody in the memory list" \
	"GEN_STRING256\n| char name\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::icuFacerecLoadSomebodyFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuFacerecLoadSomebody
interp hide {} icuFacerecLoadSomebodyFormatOutput





# FacerecUnloadSomebody ----------------------------------------------------------

if { [lsearch [interp hidden] icuFacerecUnloadSomebody] >= 0 } {
    interp expose {} icuFacerecUnloadSomebody
}
if { [lsearch [interp hidden] icuFacerecUnloadSomebodyFormatOutput] >= 0 } {
    interp expose {} icuFacerecUnloadSomebodyFormatOutput
}

proc ::icuFacerecUnloadSomebody { name args } {
    set format {}
    lappend format [list string "recoName.name" "" ]

    return [ ::cs::rqstSend "${name}" "FacerecUnloadSomebody" \
	"Request to unload somebody from the memory list" \
	"GEN_STRING256\n| char name\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::icuFacerecUnloadSomebodyFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuFacerecUnloadSomebody
interp hide {} icuFacerecUnloadSomebodyFormatOutput





# FacerecLoadEverybody ----------------------------------------------------------

if { [lsearch [interp hidden] icuFacerecLoadEverybody] >= 0 } {
    interp expose {} icuFacerecLoadEverybody
}
if { [lsearch [interp hidden] icuFacerecLoadEverybodyFormatOutput] >= 0 } {
    interp expose {} icuFacerecLoadEverybodyFormatOutput
}

proc ::icuFacerecLoadEverybody { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "FacerecLoadEverybody" \
	"Request to load everybody in the memory list" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::icuFacerecLoadEverybodyFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuFacerecLoadEverybody
interp hide {} icuFacerecLoadEverybodyFormatOutput





# FacerecUnloadEverybody ----------------------------------------------------------

if { [lsearch [interp hidden] icuFacerecUnloadEverybody] >= 0 } {
    interp expose {} icuFacerecUnloadEverybody
}
if { [lsearch [interp hidden] icuFacerecUnloadEverybodyFormatOutput] >= 0 } {
    interp expose {} icuFacerecUnloadEverybodyFormatOutput
}

proc ::icuFacerecUnloadEverybody { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "FacerecUnloadEverybody" \
	"Request to unload everybody from the memory list" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::icuFacerecUnloadEverybodyFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuFacerecUnloadEverybody
interp hide {} icuFacerecUnloadEverybodyFormatOutput





# WaitForModalityChange ----------------------------------------------------------

if { [lsearch [interp hidden] icuWaitForModalityChange] >= 0 } {
    interp expose {} icuWaitForModalityChange
}
if { [lsearch [interp hidden] icuWaitForModalityChangeFormatOutput] >= 0 } {
    interp expose {} icuWaitForModalityChangeFormatOutput
}

proc ::icuWaitForModalityChange { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "WaitForModalityChange" \
	"Wait for modality change" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::icuWaitForModalityChangeFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuWaitForModalityChange
interp hide {} icuWaitForModalityChangeFormatOutput





# LaunchPlatine ----------------------------------------------------------

if { [lsearch [interp hidden] icuLaunchPlatine] >= 0 } {
    interp expose {} icuLaunchPlatine
}
if { [lsearch [interp hidden] icuLaunchPlatineFormatOutput] >= 0 } {
    interp expose {} icuLaunchPlatineFormatOutput
}

proc ::icuLaunchPlatine { name args } {
    set format {}
    lappend format [list double "platineParams.posMin" 0.0 ]
    lappend format [list double "platineParams.posMax" 0.0 ]
    lappend format [list double "platineParams.vitesse" 0.0 ]

    return [ ::cs::rqstSend "${name}" "LaunchPlatine" \
	"Pilot the platine" \
	"ICU_PLATINE_PARAMS\n| double posMin\n| double posMax\n| double vitesse\n" \
	3 \
	$format \
	$args ]
}


proc ::icuLaunchPlatineFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuLaunchPlatine
interp hide {} icuLaunchPlatineFormatOutput





# CmdPtu ----------------------------------------------------------

if { [lsearch [interp hidden] icuCmdPtu] >= 0 } {
    interp expose {} icuCmdPtu
}
if { [lsearch [interp hidden] icuCmdPtuFormatOutput] >= 0 } {
    interp expose {} icuCmdPtuFormatOutput
}

proc ::icuCmdPtu { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "CmdPtu" \
	"Pilot the platine" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::icuCmdPtuFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuCmdPtu
interp hide {} icuCmdPtuFormatOutput





# IcuInitRFID ----------------------------------------------------------

if { [lsearch [interp hidden] icuIcuInitRFID] >= 0 } {
    interp expose {} icuIcuInitRFID
}
if { [lsearch [interp hidden] icuIcuInitRFIDFormatOutput] >= 0 } {
    interp expose {} icuIcuInitRFIDFormatOutput
}

proc ::icuIcuInitRFID { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "IcuInitRFID" \
	"Initialize RFID reader" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::icuIcuInitRFIDFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuIcuInitRFID
interp hide {} icuIcuInitRFIDFormatOutput





# IcuCloseRFID ----------------------------------------------------------

if { [lsearch [interp hidden] icuIcuCloseRFID] >= 0 } {
    interp expose {} icuIcuCloseRFID
}
if { [lsearch [interp hidden] icuIcuCloseRFIDFormatOutput] >= 0 } {
    interp expose {} icuIcuCloseRFIDFormatOutput
}

proc ::icuIcuCloseRFID { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "IcuCloseRFID" \
	"Close RFID reader connexion" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::icuIcuCloseRFIDFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuIcuCloseRFID
interp hide {} icuIcuCloseRFIDFormatOutput





# IcuAcquireRFID ----------------------------------------------------------

if { [lsearch [interp hidden] icuIcuAcquireRFID] >= 0 } {
    interp expose {} icuIcuAcquireRFID
}
if { [lsearch [interp hidden] icuIcuAcquireRFIDFormatOutput] >= 0 } {
    interp expose {} icuIcuAcquireRFIDFormatOutput
}

proc ::icuIcuAcquireRFID { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "IcuAcquireRFID" \
	"Acquire all RFID tags in the area" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::icuIcuAcquireRFIDFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuIcuAcquireRFID
interp hide {} icuIcuAcquireRFIDFormatOutput





# IcuAcquireTag ----------------------------------------------------------

if { [lsearch [interp hidden] icuIcuAcquireTag] >= 0 } {
    interp expose {} icuIcuAcquireTag
}
if { [lsearch [interp hidden] icuIcuAcquireTagFormatOutput] >= 0 } {
    interp expose {} icuIcuAcquireTagFormatOutput
}

proc ::icuIcuAcquireTag { name args } {
    set format {}
    lappend format [list string "recoTag.name" "" ]

    return [ ::cs::rqstSend "${name}" "IcuAcquireTag" \
	"Acquire specific RFID tag in the area" \
	"GEN_STRING256\n| char name\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::icuIcuAcquireTagFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuIcuAcquireTag
interp hide {} icuIcuAcquireTagFormatOutput





# ResultshumanPos ----------------------------------------------------------

if { [lsearch [interp hidden] icuResultshumanPosPosterRead] >= 0 } {
    interp expose {} icuResultshumanPosPosterRead
}
if { [lsearch [interp hidden] icuResultshumanPosPosterFormatOutput] >= 0 } {
    interp expose {} icuResultshumanPosPosterFormatOutput
}

proc ::icuResultshumanPosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "ResultshumanPos" \
	"ICU_HUMAN_POS\n| POM_SENSOR_POS\n| | int date\n| | int pad\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| | POM_EULER_V\n| | | POM_EULER\n| | | | double yaw\n| | | | double pitch\n| | | | double roll\n| | | | double x\n| | | | double y\n| | | | double z\n| | | POM_EULER_VARIANCES\n| | | | double voo\n| | | | double vop\n| | | | double vpp\n| | | | double vor\n| | | | double vpr\n| | | | double vrr\n| | | | double vox\n| | | | double vpx\n| | | | double vrx\n| | | | double vxx\n| | | | double voy\n| | | | double vpy\n| | | | double vry\n| | | | double vxy\n| | | | double vyy\n| | | | double voz\n| | | | double vpz\n| | | | double vrz\n| | | | double vxz\n| | | | double vyz\n| | | | double vzz\n| int currentModality\n| int number_of_detection\n| ICU_PERSON_POS\n| | double x\n| | double y\n| | double z\n| | int id\n| | char name\[64\]\n" \
	$args ]
}


proc ::icuResultshumanPosPosterFormatOutput { list } {
    set format { {} status { } { humanPos { } { sensorPos { } date { } pad { } { sensorToMain { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToBase { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { mainToOrigin { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } { } currentModality { } number_of_detection { 64 } { personPos { } x { } y { } z { } id { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuResultshumanPosPosterRead
interp hide {} icuResultshumanPosPosterFormatOutput





# HumanPresenceloadedPersonList ----------------------------------------------------------

if { [lsearch [interp hidden] icuHumanPresenceloadedPersonListPosterRead] >= 0 } {
    interp expose {} icuHumanPresenceloadedPersonListPosterRead
}
if { [lsearch [interp hidden] icuHumanPresenceloadedPersonListPosterFormatOutput] >= 0 } {
    interp expose {} icuHumanPresenceloadedPersonListPosterFormatOutput
}

proc ::icuHumanPresenceloadedPersonListPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "HumanPresenceloadedPersonList" \
	"ICU_RECOGNITION_WHOLIST\n| int nb\n| int unused\n| ICU_RECOGNITION_WHO\n| | char name\[256\]\n| | int present\n| | double likelihood\n| | double reliability\[56\]\n| | int window\[56\]\n| | double cumul\n| | int cptAP\n| | int curid\n| | int updated\n" \
	$args ]
}


proc ::icuHumanPresenceloadedPersonListPosterFormatOutput { list } {
    set format { {} status { } { loadedPersonList { } nb { } unused { 24 } { who { } name { } present { } likelihood { 56 } reliability { 56 } window { } cumul { } cptAP { } curid { } updated } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuHumanPresenceloadedPersonListPosterRead
interp hide {} icuHumanPresenceloadedPersonListPosterFormatOutput





# PlatineCmdcmdPlatine ----------------------------------------------------------

if { [lsearch [interp hidden] icuPlatineCmdcmdPlatinePosterRead] >= 0 } {
    interp expose {} icuPlatineCmdcmdPlatinePosterRead
}
if { [lsearch [interp hidden] icuPlatineCmdcmdPlatinePosterFormatOutput] >= 0 } {
    interp expose {} icuPlatineCmdcmdPlatinePosterFormatOutput
}

proc ::icuPlatineCmdcmdPlatinePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "PlatineCmdcmdPlatine" \
	"PLATINE_AXIS_STR\n| double pan\n| double tilt\n" \
	$args ]
}


proc ::icuPlatineCmdcmdPlatinePosterFormatOutput { list } {
    set format { {} status { } { cmdPlatine { } pan { } tilt } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuPlatineCmdcmdPlatinePosterRead
interp hide {} icuPlatineCmdcmdPlatinePosterFormatOutput





# VisualDataData ----------------------------------------------------------

if { [lsearch [interp hidden] icuVisualDataDataPosterRead] >= 0 } {
    interp expose {} icuVisualDataDataPosterRead
}
if { [lsearch [interp hidden] icuVisualDataDataPosterFormatOutput] >= 0 } {
    interp expose {} icuVisualDataDataPosterFormatOutput
}

proc ::icuVisualDataDataPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "VisualDataData" \
	"ICU_VISUAL_DATA\n| double u\n| double v\n| double scale\n| double rfidT\n| double rfidZ\n| double pan\n| double tilt\n| double x\[4\]\n| double y\[4\]\n| double z\[4\]\n| int nbSpots\n| int numRef\n" \
	$args ]
}


proc ::icuVisualDataDataPosterFormatOutput { list } {
    set format { {} status { } { Data { } u { } v { } scale { } rfidT { } rfidZ { } pan { } tilt { 4 } x { 4 } y { 4 } z { } nbSpots { } numRef } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} icuVisualDataDataPosterRead
interp hide {} icuVisualDataDataPosterFormatOutput


