/**
 ** icuCntrlTaskCodels.cc
 **
 ** Codels used by the control task icuCntrlTask
 **
 ** Author: 
 ** Date: 
 **
 **/

#include <portLib.h>

#include <stdio.h>
#include "interface.h"
#include "server/icuHeader.h"



/*------------------------------------------------------------------------
 * icuPomTaggingCntrl  -  control codel of CONTROL request PomTagging
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuPomTaggingCntrl(int *tag_on_off, int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuAutoModeCntrl  -  control codel of CONTROL request AutoMode
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */
STATUS icuAutoModeCntrl (ICU_AUTOSWITCH_CONTROL *autoSwitchControl, int *bilan)
{
  /* ... add your code here ... */
  if(autoSwitchControl->autoSwitchMode) {
    printf("AutoSwitchMode ON\n");
    Process_setModality(ICU_AUTO_SWITCH_MODE,1);
  }
  else {
    printf("AutoSwitchMode OFF\n");
    Process_setModality(ICU_NO_PROCESS,1);
  }
  return OK;
}

/*------------------------------------------------------------------------
 * icuSaveFaceCntrl  -  control codel of CONTROL request SaveFace
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuSaveFaceCntrl(int *save_face, int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuCaptureImageCntrl  -  control codel of EXEC request CaptureImage
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuCaptureImageCntrl(int *captureImage, int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuCaptureVideoCntrl  -  control codel of CONTROL request CaptureVideo
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS icuCaptureVideoCntrl (int *captureVideo, int *bilan)
{
  /* We reinit the picture number each time we stop the capture*/
  if (*captureVideo==0)
    SDI_F->pictureNumber = 0;

  /* ... add your code here ... */
  return OK;
}
/*------------------------------------------------------------------------
 * icuEnableDisplayCntrl  -  control codel of EXEC request EnableDisplay
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuEnableDisplayCntrl(ICU_AFFICHAGE *display, int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuSetCameraPosCntrl  -  control codel of EXEC request SetCameraPos
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS icuSetCameraPosCntrl (ICU_CAMERA_POS *cameraPos, int *bilan)
{
  SDI_F->cameraMove = 1;

  return OK;
}

STATUS
icuSetViamPosterCntrl(str *viamPosterName, int *report)
{
  /* ... add your code here ... */
  return OK;
}
/*------------------------------------------------------------------------
 * icuWaitForSomebodyCntrl  -  control codel of EXEC request WaitForSomebody
 *
 * Description:    
 * Report: OK
 *                 S_icu_NO_PROCESS_RUNNING
 *                 S_icu_NOBODY
 *                 S_icu_BAD_PARAMETERS
 *
 * Returns:    OK or ERROR
 */

STATUS
icuWaitForSomebodyCntrl(int *nbImageMaxNobody, int *report)
{
	//SDI_F->nbImageMaxNobody = *nbImageMaxNobody;
	if(*nbImageMaxNobody == 0)
	{
		*report = S_icu_BAD_PARAMETERS;
		return ERROR;
	}
  	return OK;
}

/*------------------------------------------------------------------------
 * icuWaitForSomeoneCntrl  -  control codel of EXEC request WaitForSomeone
 *
 * Description:    
 * Report: OK
 *                 S_icu_NO_PROCESS_RUNNING
 *                 S_icu_NOBODY
 *                 S_icu_BAD_PARAMETERS
 *
 * Returns:    OK or ERROR
 */

STATUS icuWaitForSomeoneCntrl (ICU_WAITFOR *waitFor, int *bilan)
{
	//SDI_F->waitFor.nbImageMinSomebody = waitFor->nbImageMinSomebody;
	//strcpy(SDI_F->waitFor.name, waitFor->name);
	if(waitFor->nbImageMinSomebody == 0)
	{
		printf("nbImageMinSomebody == 0\n");
		*bilan = S_icu_BAD_PARAMETERS;
		return ERROR;
	}
  	/* Si un nom de personne est donne on selectionne la personne a attendre */ 
  	if(! strcmp(waitFor->name,""))
	{
		printf("name = 0\n");
		*bilan = S_icu_BAD_PARAMETERS;
		return ERROR;
  	}
   	printf("Waiting for %s during %d images\n",waitFor->name,waitFor->nbImageMinSomebody);

	return OK;
}


/*------------------------------------------------------------------------
 * icuWaitForNobodyCntrl  -  control codel of EXEC request WaitForNobody
 *
 * Description:    
 * Report: OK
 *                 S_icu_NO_PROCESS_RUNNING
 *                 S_icu_SOMEBODY
 *                 S_icu_BAD_PARAMETERS
 *
 * Returns:    OK or ERROR
 */

STATUS icuWaitForNobodyCntrl (int *nbImageMaxNobody, int *bilan)
{
	//SDI_F->nbImageMaxNobody = *nbImageMaxNobody;
	if(*nbImageMaxNobody == 0)
	{
		*bilan = S_icu_BAD_PARAMETERS;
		return ERROR;
	}
  	return OK;
}


/*------------------------------------------------------------------------
 * icuWaitForNoneCntrl  -  control codel of EXEC request WaitForNone
 *
 * Description:    
 * Report: OK
 *                 S_icu_NO_PROCESS_RUNNING
 *                 S_icu_SOMEBODY
 *                 S_icu_BAD_PARAMETERS
 *
 * Returns:    OK or ERROR
 */
STATUS icuWaitForNoneCntrl (ICU_WAITFOR *waitFor, int *bilan)
{
	//SDI_F->waitFor.nbImageMinSomebody = waitFor->nbImageMinSomebody;
	//strcpy(SDI_F->waitFor.name, waitFor->name);
	if(waitFor->nbImageMinSomebody == 0)
	{
		printf("nbImageMinSomebody == 0\n");
		*bilan = S_icu_BAD_PARAMETERS;
		return ERROR;
	}
  	/* Si un nom de personne est donne on selectionne la personne a attendre */ 
  	if(! strcmp(waitFor->name,""))
	{
		printf("name = 0\n");
		*bilan = S_icu_BAD_PARAMETERS;
		return ERROR;
  	}
    printf("Waiting for %s during %d images\n",waitFor->name,waitFor->nbImageMinSomebody);
	return OK;
}

/*------------------------------------------------------------------------
 * icuWaitForNobodyKnownCntrl  -  control codel of EXEC request WaitForNobodyKnown
 *
 * Description:    
 * Report: OK
 *                 S_icu_NO_PROCESS_RUNNING
 *                 S_icu_SOMEBODY
 *                 S_icu_BAD_PARAMETERS
 *
 * Returns:    OK or ERROR
 */
STATUS icuWaitForNobodyKnownCntrl (int *nbImageMaxNobody, int *bilan)
{
	//SDI_F->nbImageMaxNobody = *nbImageMaxNobody;
	if(*nbImageMaxNobody == 0)
	{
		*bilan = S_icu_BAD_PARAMETERS;
		return ERROR;
	}
  	return OK;
}

/*------------------------------------------------------------------------
 * icuWaitForPersonListChangeCntrl  -  control codel of EXEC request WaitForPersonListChange
 *
 * Description:    
 * Report: OK
 *                 S_icu_NO_PROCESS_RUNNING
 *
 * Returns:    OK or ERROR
 */

/*STATUS
icuWaitForPersonListChangeCntrl(ICU_PERSON_LIST_PARAMS *paramsPersonList, int *report)
{
  
  return OK;
}*/
STATUS icuWaitForPersonListChangeCntrl(ICU_PERSON_LIST_PARAMS *p, int *bilan)
{
	SDI_F->personListChanged = 0;
	SDI_F->paramsPersonList.presenceWindow = p->presenceWindow;
	SDI_F->paramsPersonList.absenceWindow = p->absenceWindow;
	SDI_F->paramsPersonList.seuilReco = p->seuilReco;
	SDI_F->paramsPersonList.absenceRatio = p->absenceRatio;
	SDI_F->paramsPersonList.presenceRatio = p->presenceRatio;
  return OK;
}


/*------------------------------------------------------------------------
 * icuProcessSetModalityCntrl  -  control codel of EXEC request ProcessSetModality
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuProcessSetModalityCntrl(ICU_MODALITIES *setModality, int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuFacerecSetWorkingPathCntrl  -  control codel of EXEC request FacerecSetWorkingPath
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuFacerecSetWorkingPathCntrl(GEN_STRING256 *facerecWorkingPath, int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuFacerecSetParamsCntrl  -  control codel of EXEC request FacerecSetParams
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS icuFacerecSetParamsCntrl(ICU_PERSON_LIST_PARAMS *p, int *bilan) 
{   
  if(p->seuilReco>0 && p->seuilReco<=1 
    && p->absenceWindow>0 && p->absenceWindow<ICU_NB_MAX_TEMPORAL_WINDOW 
    && p->presenceWindow>0 && p->presenceWindow<ICU_NB_MAX_TEMPORAL_WINDOW 
    && p->absenceRatio>0 && p->absenceRatio<=1 
    && p->presenceRatio>0 && p->presenceRatio<=1) 
    return OK;
  else
    return ERROR;
}

/*------------------------------------------------------------------------
 * icuFacerecInitCntrl  -  control codel of EXEC request FacerecInit
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuFacerecInitCntrl(int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuFacerecAddSomebodyCntrl  -  control codel of EXEC request FacerecAddSomebody
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */
STATUS icuFacerecAddSomebodyCntrl(GEN_STRING256* recoAddName, int *bilan)
{
  /** On indique le mode apprentissage */
  SDI_F->recoAddSomebody = ICU_NB_FACES_IN_RECO_DATABASE;
  
  /** On incremente l'id */
  SDI_F->recoId++;

  /** On positionne la modalite de detection de visage pour faire l'apprentissage */
  Process_setModality(ICU_FACE_DETECTION,0);
  
  /** On desactive l'affichage du process pour traiter l'ajout des imagettes sans trace */
  //Process_disableDisplay();
  
  //printf("SDI_F->recoAddSomebody = %d\n",SDI_F->recoAddSomebody);
  
  return OK;
}

/*------------------------------------------------------------------------
 * icuFacerecSetPeopleCntrl  -  control codel of EXEC request FacerecSetPeople
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuFacerecSetPeopleCntrl(GEN_STRING256 *recoName, int *report)
{
  /* ... add your code here ... */
  return OK;
}


/*------------------------------------------------------------------------
 * icuFacerecRecognizeAllCntrl  -  control codel of EXEC request FacerecRecognizeAll
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuFacerecRecognizeAllCntrl(int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuFacerecLoadSomebodyCntrl  -  control codel of EXEC request FacerecLoadSomebody
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuFacerecLoadSomebodyCntrl(GEN_STRING256 *recoName, int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuFacerecUnloadSomebodyCntrl  -  control codel of EXEC request FacerecUnloadSomebody
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuFacerecUnloadSomebodyCntrl(GEN_STRING256 *recoName, int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuFacerecLoadEverybodyCntrl  -  control codel of EXEC request FacerecLoadEverybody
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuFacerecLoadEverybodyCntrl(int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuFacerecUnloadEverybodyCntrl  -  control codel of EXEC request FacerecUnloadEverybody
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuFacerecUnloadEverybodyCntrl(int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuWaitForModalityChangeCntrl  -  control codel of EXEC request WaitForModalityChange
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuWaitForModalityChangeCntrl(int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuLaunchPlatineCntrl  -  control codel of EXEC request LaunchPlatine
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuLaunchPlatineCntrl(ICU_PLATINE_PARAMS *platineParams, int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuInitRFIDCntrl  -  control codel of EXEC request IcuInitRFID
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuInitRFIDCntrl(int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuCloseRFIDCntrl  -  control codel of EXEC request IcuCloseRFID
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuCloseRFIDCntrl(int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuAcquireRFIDCntrl  -  control codel of EXEC request IcuAcquireRFID
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuAcquireRFIDCntrl(int *report)
{
  /* ... add your code here ... */
  return OK;
}

/*------------------------------------------------------------------------
 * icuAcquireTagCntrl  -  control codel of EXEC request IcuAcquireTag
 *
 * Description:    
 * Report: OK
 *
 * Returns:    OK or ERROR
 */

STATUS
icuAcquireTagCntrl(GEN_STRING256 *recoTag, int *report)
{
  /* ... add your code here ... */
  return OK;
}


