#include "list.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>


tagList  *listExternalTag=NULL; 
tagList  *lastExternalTag=NULL;
int nbExternalTags_detec=0;



internalList  *listInternalTag=NULL; 
internalList  *lastInternalTag=NULL;
int nbInternalTags_detec=0;

#define NBANT 8



/***********************************************\
 *                 reset_ _rec                   *
 * recursive function to free the list of tags *
\***********************************************/
static void reset_External_rec(tagList *ite){
	if (ite->next!=NULL){
			reset_External_rec(ite->next);
	}
	free(ite);
}

static void reset_Internal_rec(internalList *ite){
	if (ite->next!=NULL){
			memset(ite->Tag->last_detec,0,NBANT);
			reset_Internal_rec(ite->next);
	}
	free(ite);
}


/***********************************************\
 *                 reset_ _List                  *
 *     Function to free the list of tags       *
 *                            *
\***********************************************/

void reset_External_list(){
	if (listExternalTag != NULL)
		reset_External_rec(listExternalTag);
	listExternalTag=NULL;
	lastExternalTag=NULL;
	nbExternalTags_detec=0;
}
void reset_Internal_list(){
	if (listInternalTag != NULL)
		reset_Internal_rec(listInternalTag);
	listInternalTag=NULL;
	lastInternalTag=NULL;
	nbInternalTags_detec=0;
}



/***********************************************\
 *                 searchTag                   *
\***********************************************/
internalTag *searchTagIntern(char *Tag_ID){
	internalList *ite=listInternalTag;
	while (ite!=NULL){
		if (!strcmp(ite->Tag->Tag_ID,Tag_ID)) return ite->Tag;
		ite=ite->next;
	}
	return NULL;
}

externalTag *searchTagExtern(char *Tag_ID){
	tagList *ite=listExternalTag;
	while (ite!=NULL){
		if (!strcmp(ite->Tag->Tag_ID,Tag_ID)) return ite->Tag;
		ite=ite->next;
	}
	return NULL;
}


/**********************************\
 *  		store_Internal_Tag             *
\**********************************/
void store_Internal_Tag(char *Tag_ID,int antenna){
	internalTag *newTag;
	internalList *ord;
	
	ord=(internalList *)malloc(sizeof(internalList));
	
	newTag=searchTagIntern(Tag_ID);
	/* If the tag has already been seen */
 	if (newTag!=NULL){
		newTag->last_detec[antenna]=1;
 	}
 	else{/* the tag is a new one */
 		newTag=(internalTag *)malloc(sizeof(internalTag));
		memset(newTag, 0, sizeof(internalTag));
 		strcpy(newTag->Tag_ID,Tag_ID);
			
		newTag->Tag_MEMORY=NULL;

		newTag->last_detec[antenna]=1;
		
		ord->Tag = newTag;

		if(listInternalTag == NULL)
		{
			ord->next = NULL;
		}
		else
		{
			ord->next = listInternalTag;
		}

		listInternalTag = ord;
		nbInternalTags_detec++;
 	}/*end if existing...*/
}/*end function*/
 
 
 /**************************************************************\
 *			getTagInfo
\**************************************************************/
externalTag *getTagInfo(internalTag *Tag){

	externalTag *existing = (externalTag *)malloc(sizeof(externalTag));
	angleproba param;
	/* If the tag has already been seen */	
	param=angle_of_tag(Tag); 
	existing->angle=param.angle;
	switch(param.nbAnt){
	case 1:
		existing->longueur=410;
		existing->ecartTypeLongueur=29.9472;
		existing->ecartTypeAngle=6.9257;
		break;
	case 2:
		existing->longueur=302;
		existing->ecartTypeLongueur=137.0416;
		existing->ecartTypeAngle=10.0149;
		break;
	case 3:
		existing->longueur=177;
		existing->ecartTypeLongueur=147.1968;
		existing->ecartTypeAngle=6.3006;
		break;
	default:
	break;
	}
	return existing;
}
/**************************************************\
 * get_Internal_Tag_by_pos (by its position in the arranged list) 
\**************************************************/
internalTag *get_Internal_Tag_by_pos(int position){
	internalList *ite=listInternalTag;

	if (position >= nbInternalTags_detec || position < 0)
	{
		return NULL;
	}
	while(position>0)
	{
		ite=ite->next;
		position--;
	}
	return ite->Tag;
}


/**************************************************\
 * get_Internal_Tag_by_Id (by its position in the arranged list) 
\**************************************************/
internalTag *get_Internal_Tag_by_Id(char *Tag_ID){
	internalList *ite=listInternalTag;
	while (ite!=NULL){
		if (!strcmp(ite->Tag->Tag_ID,Tag_ID)) return ite->Tag;
		ite=ite->next;
	}
	return NULL;
}


/**************************************************\
 * angle_of_tag
\**************************************************/

angleproba angle_of_tag(internalTag *courant)
{
	
        unsigned int ant,k,j;
        angleproba retour;
        double angle;
       	retour.nbAnt=0;
        /*real acquisition function implemented in fonctions.c*/

//         courant = get_Internal_Tag_by_Id(courant);
       // if (courant!=NULL){
        //printf("hohoho ");
        ant=0;
        k=1;
        for (j=0;j<NBANT;j++) 
	{			
                if (courant->last_detec[j]>0) 
		{
                        ant+=k;
                        retour.nbAnt+=1;
                }
                k*=2;
        }// end for j

        switch (ant) {
        case 1:
        case 131: //128+1+2
                angle=0;
                break;
        case 2:
        case 7: //1+2+4
                angle=45;
                break;
        case 4:
        case 14: //2+4+8
                angle=90;
                break;
        case 8:
        case 28: //4+8+16
                angle=135;
                break;
        case 16:
        case 56: //8+16+32
                angle=180;
                break;
        case 32:
        case 112: //16+32+64
                angle=225;
                break;
        case 64:
        case 224://32+64+128
                angle=270;
                break;
        case 128:
        case 193://64+128+1
                angle=315;
                break;
        case 3: //1+2
                angle=22.5;//22.5
                break;
        case 6:	//2+4
                angle=67;//67.5
                break;
        case 12://4+8
                angle=112;//112.5
                break;
        case 24://8+16
                angle=157;//157.5
                break;
        case 48://16+32
                angle=202;//202.5
                break;
        case 96://32+64
                angle=247;//247.5
                break;
        case 192://64+128
                angle=292;//292.5
                break;
        case 129://128+1
                angle=337;//337.5
                break;
        default:
                angle=-1;
                break;
        }
       retour.angle=angle;
        return  retour;
//}
}
