#include "multibspline2d.h"
#include <cv.h>
#include <highgui.h>


void Show(char* nm,IplImage* imgview, int pause=0)
{
  cvNamedWindow(nm,0);
  cvShowImage(nm,imgview);
  if(pause) cvWaitKey(0);
}
void Show(char* nm,IplImage* imgview, int x, int y, int pause=0)
{
  Show(nm,imgview,0);
  cvMoveWindow(nm,x,y);
  if(pause) cvWaitKey(0);
}

int main(void)
{
  int espace = 15;

  char ficspline[100] = "/home/lbrethes/DEVEL/NewTrack2d/track2d/config/shapes/Lhand.dat";
  char ficconfig[100] = "/home/lbrethes/DEVEL/NewTrack2d/track2d/config/shapes/Lhand_config.dat";

  MultiBSpline2D* spline =  new MultiBSpline2D(ficspline,ficconfig);


  IplImage* img = cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3);
  IplImage* img2 = cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3); 
  IplImage* img3 = cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3);

  //Centre
  spline->transform(160,120,0,4,0);
  cvZero(img);
  cvZero(img2);
  cvZero(img3);
  spline->draw(img,CV_RGB(0,0,255));
  spline->draw_mask_fcol(img2);
  spline->draw_all_regions_fcol(img3);
  Show("spline",img,0,0);
  Show("spline2",img2,img->width+espace,0); 
  Show("spline3",img3,(2*img->width)+espace,0,1);

IplImage* c1 = cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3);
IplImage* c2 = cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3);
IplImage* c3 = cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3);
IplImage* c4 = cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3);
IplImage* c5 = cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3);
IplImage* c6 = cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3);
IplImage* c7 = cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3);

 spline->draw_one_mask_fcol(c1,0);
 spline->draw_one_mask_fcol(c2,1);
 spline->draw_one_mask_fcol(c3,2);
 spline->draw_one_mask_fcol(c4,3);
 spline->draw_one_mask_fcol(c5,4);
 spline->draw_one_mask_fcol(c6,5);
 spline->draw_global_rect(c7,CV_RGB(255,255,255));

 Show("c1",c1);
 Show("c2",c2);
 Show("c3",c3);
 Show("c4",c4);
 Show("c5",c5);
 Show("c6",c6);
 Show("c7",c7,1);

  //Variation d'echelle
  for(int i=1;i<50;i+=1)
    {
      spline->transform(160,120,0,(float)i/10.0,0);
      cvZero(img);
      cvZero(img2);
      cvZero(img3);
      spline->draw(img,CV_RGB(0,0,255));
      spline->draw_mask_fcol(img2);
      spline->draw_all_regions_fcol(img3);
      Show("spline",img,0,0);
      Show("spline2",img2,img->width+espace,0); 
      Show("spline3",img3,(2*img->width)+espace,0,0);
      cvWaitKey(100);
    }

  //Variation d'orientation
  for(int i=-100;i<100;i+=1)
    {
      spline->transform(160,120,(float)i/100.0,4,0);
      cvZero(img);
      cvZero(img2);
      cvZero(img3);
      spline->draw(img,CV_RGB(0,0,255));
      spline->draw_mask_fcol(img2);
      spline->draw_all_regions_fcol(img3);
      Show("spline",img,0,0);
      Show("spline2",img2,img->width+espace,0); 
      Show("spline3",img3,(2*img->width)+espace,0,0);
      cvWaitKey(50);
    }
}
