#include <cv.h>
#include <highgui.h>

#include "applipath.h"
#include "ColorDistribution.h"

void test_ColorDistribution()
{
  
  IplImage* img = cvLoadImage("cap000.jpg",-1);
  int nbparts=4;

  IplImage* mask = cvCreateImage(cvGetSize(img),IPL_DEPTH_8U,1);
  cvZero(mask);
  IplImage* maskCOL = cvCreateImage(cvGetSize(img),IPL_DEPTH_8U,3);
  cvZero(maskCOL);

  /* Selection d'un carre */
  CvPoint ptUL;
  CvPoint ptLR;
  int w=40;
  int h=80;
  int x=50;
  int y=80;
  int* nbpix;
  string fen;

  nbpix = new int[nbparts];

  ptUL.x = x;
  ptUL.y = y;
  ptLR.x = ptUL.x + w;
  ptLR.y = ptUL.y + h;
  CvRect rect = cvRect(x,y,w,h);

  CvPoint* ptULList;
  CvPoint* ptLRList;
  CvRect* rectList;
  
  ptULList = (CvPoint*)calloc(nbparts,sizeof(CvPoint));
  ptLRList = (CvPoint*)calloc(nbparts,sizeof(CvPoint));
  rectList = (CvRect*)calloc(nbparts,sizeof(CvRect));

  /* on test avec la meme zone pour chaque histo */
  for(int i=0;i<nbparts;i++)
    {
      ptULList[i].x = x+i*w;
      ptULList[i].y = y;
      ptLRList[i].x = ptULList[i].x + w;
      ptLRList[i].y = ptULList[i].y + h;
      cvRectangle(mask,ptULList[i],ptLRList[i],cvScalar(i+1),-1,8,0 );
      cvRectangle(maskCOL,ptULList[i],ptLRList[i],cvScalar((i+1)*32,i*16,i*2),-1,8,0 );

      nbpix[i] = w*h;
    }

  cvNamedWindow("MASK",0);
  cvShowImage("MASK",mask); 
  cvNamedWindow("MASKCOL",0);
  cvShowImage("MASKCOL",maskCOL);
  cvWaitKey(0);

  /* alloc d'une classe distribution de couleur */
  ColorDistribution* coldist;
  coldist = new ColorDistribution(nbparts,img->width,img->height,nbpix);

  coldist->CalcFromRectList(img,ptULList,ptLRList);

  fen = "Histo";
  coldist->Disp(fen,0); 

  /* alloc d'une classe distribution de couleur */
  ColorDistribution* coldist2;
  coldist2 = new ColorDistribution(nbparts,img->width,img->height,nbpix);
  coldist2->CalcFromMask(img,ptULList[0],ptLRList[nbparts-1],mask);
  fen = "Histo par mask";
  coldist2->Disp(fen,1);

  delete [] nbpix;
}


int main(void)
{
  test_ColorDistribution();
}
