#include <stdio.h>
#include "Gaussian.h"
#include "Gaussian1D.h"
#include "Gaussian2D.h"
#include "Gaussian3D.h"
#include "Gaussian4D.h"
#include "GaussianND.h"

#include "GaussianDiag2D.h"
#include "GaussianDiag3D.h"
#include "GaussianDiag4D.h"
#include "GaussianDiagND.h"

#include "GaussianMixture.h"

#include <cv.h>
#include <highgui.h>
#include <math.h>
#include <iostream>
using namespace std;

/*
 *  Pour compiler
g++ -o test test.cpp -I/usr/local/OpenCV/include/opencv -I../include -L/usr/local/OpenCV/lib -lcv -lcxcore -lhighgui -Wno-deprecated -lstdc++ -lm -L../../build/libicu/.libs -licu

*/

int nb = 4;
int dim = 2;
double m[] = {160,120};
double cov[] = {100,0,0,100};
GaussianMixture *gm;
double cpt[]={0.0,0.0,0.0,0.0};
double res[2];
int nbTirs = 1000000;


void TirsEval() {
  cpt[0] = 0;
  cpt[1] = 0;
  cpt[2] = 0;
  cpt[3] = 0;
  /* Tirs successifs puis comptabilisation dans les 4 zones */
  for(int i=0;i<nbTirs;i++) {
    gm->Draw(res);
    double d0 = sqrt(pow(gm->glist[0]->mean[0]-res[0],2)+pow(gm->glist[0]->mean[1]-res[1],2));
    double d1 = sqrt(pow(gm->glist[1]->mean[0]-res[0],2)+pow(gm->glist[1]->mean[1]-res[1],2));
    double d2 = sqrt(pow(gm->glist[2]->mean[0]-res[0],2)+pow(gm->glist[2]->mean[1]-res[1],2));
    double d3 = sqrt(pow(gm->glist[3]->mean[0]-res[0],2)+pow(gm->glist[3]->mean[1]-res[1],2));
    int idmin = ( d0 < d1 ? ( d0 < d2 ? (d0 < d3 ? 0 : 3) : (d2 < d3 ? 2 : 3) ) : ( d1 < d2 ? (d1 < d3 ? 1 : 3) : (d2 < d3 ? 2 : 3) ) );
    cpt[idmin]+=1.0;
  }
  cout << "Res = ";
  cout << cpt[0]/(double)nbTirs << " | ";
  cout << cpt[1]/(double)nbTirs << " | ";
  cout << cpt[2]/(double)nbTirs << " | ";
  cout << cpt[3]/(double)nbTirs << endl;
}

void testGaussianMixture() {

  cout << endl << "\t E V A L U A T I O N   A V E C  " << nbTirs << "  T I R S" << endl << endl;
  
  gm = new GaussianMixture(nb,dim,m,cov);

  /* On positionne les gaussiennes */
  gm->glist[0]->mean[0] = 50;
  gm->glist[0]->mean[1] = 50;

  gm->glist[1]->mean[0] = 50;
  gm->glist[1]->mean[1] = 270;

  gm->glist[2]->mean[0] = 190;
  gm->glist[2]->mean[1] = 50;

  gm->glist[3]->mean[0] = 190;
  gm->glist[3]->mean[1] = 270;

  cout << "=========================================================================" << endl;
  cout << " G A U S S I E N N E S   E Q U I P R O B A B L E S  (0.25,0.25,0.25,0.25)" << endl;
  cout << "=========================================================================" << endl;
  TirsEval();
  cout << endl;

  /* On modifie les poids de la mixture */
  double newCoeff[] = {0.10,0.30,0.20,0.40};
  gm->updateMixtureCoeff(newCoeff,1);

  cout << "===================================================" << endl;
  cout << " P O I D S   M O D I F I E S  (0.10,0.30,0.20,0.40)" << endl;
  cout << "===================================================" << endl;
  TirsEval();
  cout << endl;
}

int main(void) {
  testGaussianMixture();
}
