#include <stdio.h>
#include "Gaussian.h"
#include "Gaussian1D.h"
#include "Gaussian2D.h"
#include "Gaussian3D.h"
#include "Gaussian4D.h"
#include "GaussianND.h"

#include "GaussianDiag2D.h"
#include "GaussianDiag3D.h"
#include "GaussianDiag4D.h"
#include "GaussianDiagND.h"

#include "GaussianAlloc.h"

//#include "GaussianMixture.h"
#include "matrixutils.h"
#include "calclut.h"
#include "temps_cpu.h"

#include <cv.h>
#include <highgui.h>

#define TYPE double
#define TEV double


/*
 *  Pour compiler
 *  g++ -o test test.cpp -I/usr/local/include/opencv -I../../include -L../../lib -lmyprocs -L/usr/local/lib -lcv -lcxcore -lhighgui -Wno-deprecated

 ou make test
*/


void test1();
{
  Gaussian<TYPE,TEV>* gauss;

  gauss = GaussianAlloc<TYPE,TEV>("gauss1d.txt");
  gauss->Disp();
  delete gauss;
  gauss = GaussianAlloc<TYPE,TEV>("gauss2d.txt");
  gauss->Disp();
  delete gauss;
  gauss = GaussianAlloc<TYPE,TEV>("gauss3d.txt");
  gauss->Disp();
  delete gauss;
  gauss = GaussianAlloc<TYPE,TEV>("gauss4d.txt");
  gauss->Disp();
  delete gauss;
  gauss = GaussianAlloc<TYPE,TEV>("gauss6d.txt");
  gauss->Disp();
  delete gauss;
  return 1;
}

void test2()
{
  int N=100;

  Gaussian<TYPE,TEV>* g;

  g = new Gaussian1D<TYPE,TEV>("gauss1d.txt");
  g->Disp("Gaussienne 1D chargee depuis un fichier");

  TYPE val[4];
  TYPE sum[4];
  sum[0] = 0;
  for(int i=0;i<N;i++)
    {
      g->Draw(val);
      cout << "Draw = " << val[0] << "   eval = " << g->Eval(val) << endl;
      sum[0]+=val[0];
    }
  cout << "Draw Moyen = " << sum[0]/N << endl << endl;

  delete g;

  g = new Gaussian2D<TYPE,TEV>("gauss2d.txt");
  g->Disp("Gaussienne 2D chargee depuis un fichier");

  sum[0] = 0;
  sum[1] = 0;
  //cout << "X = [";
  for(int i=0;i<N;i++)
    {
      g->Draw(val);
      cout << "Draw = " << val[0] << "  " << val[1] << "   eval = " << g->Eval(val) << endl;
      //cout << val[0] << " " << val[1] << " " << g->Eval(val) << ";" << endl;
      sum[0]+=val[0];
      sum[1]+=val[1];
    }
  //cout << "];" << endl;
  cout << "Draw Moyen = " << sum[0]/N << "  " << sum[1]/N << endl << endl;

 delete g;

  g = new Gaussian3D<TYPE,TEV>("gauss3d.txt");
  g->Disp("Gaussienne 3D chargee depuis un fichier");

  sum[0] = 0;
  sum[1] = 0;
  sum[2] = 0;
  //cout << "X = [";
  for(int i=0;i<N;i++)
    {
      g->Draw(val);
      cout << "Draw = " << val[0] << "  " << val[1] << "  " << val[2] << "   eval = " << g->Eval(val) << endl;
      //cout << val[0] << " " << val[1] << " " << g->Eval(val) << ";" << endl;
      sum[0]+=val[0];
      sum[1]+=val[1];
      sum[2]+=val[2];
    }
  //cout << "];" << endl;
  cout << "Draw Moyen = " << sum[0]/N << "  " << sum[1]/N << "  " << sum[2]/N<< endl << endl;
  delete g;

  g = new Gaussian4D<TYPE,TEV>("gauss4d.txt");
  g->Disp("Gaussienne 4D chargee depuis un fichier");

  sum[0] = 0;
  sum[1] = 0;
  sum[2] = 0;
  sum[3] = 0;
  //cout << "X = [";
  for(int i=0;i<N;i++)
    {
      g->Draw(val);
      cout << "Draw = " << val[0] << "  " << val[1] << "  " << val[2] << "  " << val[3] << "   eval = " << g->Eval(val) << endl;
      //cout << val[0] << " " << val[1] << " " << g->Eval(val) << ";" << endl;
      sum[0]+=val[0];
      sum[1]+=val[1];
      sum[2]+=val[2];
      sum[3]+=val[3];
    }
  //cout << "];" << endl;
  cout << "Draw Moyen = " << sum[0]/N << "  " << sum[1]/N << "  " << sum[2]/N << "  " << sum[3]/N << endl << endl;

  delete g;

  cout << "Comparaison des temps de calcul entre une gaussienne ND avec N=3 et une gaussienne 3D et gaussienne Diag3D" << endl;
  g = new Gaussian3D<TYPE,TEV>("gauss3d.txt");
  g->Disp("Gaussienne 3D chargee depuis un fichier");

  Gaussian<TYPE,TEV>* g2;
  g2 = new GaussianND<TYPE,TEV>("gauss3d.txt");
  g2->Disp("Gaussienne ND chargee depuis un fichier");

  Gaussian<TYPE,TEV>* g3;
  g3 = new GaussianDiag3D<TYPE,TEV>("gauss3d.txt");
  g3->Disp("Gaussienne Diag3D chargee depuis un fichier");


  g->Draw(val);
  cout << "ND : " << g2->Eval(val) << "  " << "3D : " << g->Eval(val) << "  " << "Diag3D : " << g3->Eval(val) << "  " << endl;
  getchar();

  N=1000000;
  cout << N << " Tir Eval avec GaussianND" << endl;
  get_time_start();
  for(int i=0;i<N;i++)
    {
      g2->Draw(val);
      g2->Eval(val);
    }
  get_time_stop();

  cout << N << " Tir Eval avec Gaussian3D" << endl;
  get_time_start();
  for(int i=0;i<N;i++)
    {
      g->Draw(val);
      g->Eval(val);
    }
  get_time_stop();

  cout << N << " Tir Eval avec GaussianDiag3D" << endl;
  get_time_start();
  for(int i=0;i<N;i++)
    {
      g3->Draw(val);
      g3->Eval(val);
    }
  get_time_stop();

  return 1;
}

int main(void)
{
  test2();
}
