#include "eigenbase.h"

//********************************
  //NE PAS TOUCHER POUR LE MOMENT !!!!!!!
int eigenbase::nBase=0;
const int eigenbase::DFFS = -1;
//const int eigenbase::CLASS = 1;
const int eigenbase::CHNG = 0;
const int eigenbase::OK = 1;
//*******************************


  //Realise un pretraitement a l image d entree
  //Choix = 1 : egalisation de l histogramme
  //Choix = 2 : application de 2 filtres successifs. 
  //				Un filtre qui adouci les contours
  //				puis un filtre qui accentue les contours
void eigenbase::preTraiter(IplImage* imgIn, int choix)
{
  switch(choix)
    {
    case 1:
      eigenbase::equalize(imgIn);
      break;
    case 2:
      {
	double smoothFilterTab[] = {  1, 1, 1,
				      1, 5, 1,
				      1, 1, 1};
	CvMat smoothFilter = cvMat(3, 3, CV_64FC1, smoothFilterTab);
	IplImage* imgSmooth = cvCloneImage(imgIn);
	for(int i=1;i<29;i++)
	  {
	    for(int j=1;j<29;j++)
	      {
		CvScalar somme;
		somme.val[0] = 0.0;
		for(int k=-1;k<=1;k++)
		  {
		    for(int l=-1;l<=1;l++)
		      {
			CvScalar tmp = cvGet2D(imgIn, i+k, j+l);
			somme.val[0] += tmp.val[0] * cvmGet(&smoothFilter, k+1, l+1);
		      }
		  }
		somme.val[0] /= 13;
		cvSet2D(imgSmooth, i, j, somme);
	      }
	  }

	double contourFilterTab[] = { -1, -1, -1,
				      -1,  8, -1,
				      -1, -1, -1};
	CvMat contourFilter = cvMat(3, 3, CV_64FC1, contourFilterTab);
	for(int i=1;i<29;i++)
	  {
	    for(int j=1;j<29;j++)
	      {
		CvScalar somme;
		somme.val[0] = 0.0;
		for(int k=-1;k<=1;k++)
		  {
		    for(int l=-1;l<=1;l++)
		      {
			CvScalar tmp = cvGet2D(imgIn, i+k, j+l);
			somme.val[0] += tmp.val[0] * cvmGet(&contourFilter, k+1, l+1);
		      }
		  }
		somme.val[0] /= 8;
		cvSet2D(imgIn, i, j, somme);
	      }
	  }
	eigenbase::equalize(imgIn);
      }
      break;
    }

}

//Egalise l histogramme de l image d entree
void eigenbase::equalize(IplImage* imgIn)
{

  /*IplImage* ell = cvCloneImage(imgIn);
  cvZero(ell);
  cvEllipse(ell, cvPoint(15,15), cvSize(13,11), 90.0, 0, 360, cvScalar(255), CV_FILLED);*/

  double min;
  double max;
  CvPoint* minLoc = new CvPoint();
  CvPoint* maxLoc = new CvPoint();
	
  //Normalise (pour plus de suret)
  cvMinMaxLoc(imgIn, &min, &max, minLoc, maxLoc);
  cvConvertScale(imgIn, imgIn, 1, -min);
  cvConvertScale(imgIn, imgIn, 255/(max-min), 0);

  //puis egalise
  cvEqualizeHist(imgIn, imgIn);

  /*cvAnd(imgIn, ell, imgIn);
  cvReleaseImage(&ell);*/

  delete minLoc;
  delete maxLoc;
}

//Permet d afficher 4 images dans une seule fenetre ...
void cvShowImages(char* title, IplImage* img1, IplImage* img2, IplImage* img3, IplImage* img4)
{
  IplImage* DispImage = cvCreateImage(cvSize(120, 30), 8, 1);

  cvSetImageROI(DispImage, cvRect(0, 0, 30, 30));
  cvResize(img1, DispImage);
  cvResetImageROI(DispImage);

  cvSetImageROI(DispImage, cvRect(30, 0, 30, 30));
  cvResize(img2, DispImage);
  cvResetImageROI(DispImage);

  cvSetImageROI(DispImage, cvRect(60, 0, 30, 30));
  cvResize(img3, DispImage);
  cvResetImageROI(DispImage);

  cvSetImageROI(DispImage, cvRect(90, 0, 30, 30));
  cvResize(img4, DispImage);
  cvResetImageROI(DispImage);

  cvShowImage(title, DispImage);
}

//Constructeur
eigenbase::eigenbase(int typ)
{
  eigenbase::nBase ++;
  this->avg = NULL;
  this->eigenObjects = NULL;
  this->eigVals = NULL;
  this->objects.clear();
  this->size = cvSize(30,30);
  this->nbValP = 0;
  this->type = typ;
  this->nObjects = 0;
  this->nApp = 0;
  this->state = eigenbase::OK;
  for(int i=0;i<30;i++)
    {
      for(int j=0;j<30;j++)
	{
	  this->gauss[i][j] = 0.0;
	}
    }

  switch(eigenbase::nBase)
    {
    case 0:
      this->color = CV_RGB(0,255,0);
      break;
    case 1:
      this->color = CV_RGB(0,0,255);
      break;
    case 2:
      this->color = CV_RGB(255,255,0);
      break;
    case 3:
      this->color = CV_RGB(0,255,255);
      break;
    case 4:
      this->color = CV_RGB(255,0,255);
      break;
    case 5:
      this->color = CV_RGB(255,255,255);
      break;
    default:
      this->color = CV_RGB(255,0,0);
    }
}

//Destructeur
eigenbase::~eigenbase(void)
{
  cout << "1\n";
  for(unsigned int i=0;i<this->objects.size();i++)
    {
      cvReleaseImage(&this->objects[i]);
      cvReleaseImage(&this->eigenObjects[i]);
    }
  cout << "2\n";
  this->objects.clear();
  cout << "3\n";
  if(this->eigenObjects)
    delete [] this->eigenObjects;
  cout << "4\n";
  cvReleaseImage(&this->avg);
  cout << "5\n";
  if(this->eigVals)
    delete [] this->eigVals;
}

//Initialise la base en realisant une ACP
void eigenbase::init()
{
  //Critere d arret
  CvTermCriteria calcLimit;
  calcLimit.type = CV_TERMCRIT_NUMBER;
  calcLimit.max_iter = this->objects.size() - 1;
  
  //Allocation du tableau de valeurs propres
  //this->eigVals = (float*) cvAlloc(this->objects.size()*sizeof(float));
  this->eigVals = new float[this->objects.size()];
  
  //Allocation de l image moyenne
  this->avg = cvCreateImage( this->getSize(), IPL_DEPTH_32F, 1 );
  
  //Creation d un tableau d images
  //IplImage** obj = (IplImage**) cvAlloc(this->objects.size()*sizeof(IplImage*));
  //IplImage** base = (IplImage**) cvAlloc(this->nApp*sizeof(IplImage*));
  //Allocation du tableau des vecteurs propres
  //this->eigenObjects = (IplImage**) cvAlloc(this->objects.size()*sizeof(IplImage*));

  IplImage** obj = new IplImage*[this->objects.size()];
  IplImage** base = new IplImage*[this->nApp];
  this->eigenObjects = new IplImage*[this->objects.size()];
  
  //Recopie des objets de la base, et creation desimages propres
  for(unsigned int i=0;i<this->objects.size();i++)
    {
      obj[i] = this->objects[i];
      this->eigenObjects[i] = cvCreateImage(this->getSize(), IPL_DEPTH_32F, 1);
    }
  
  //Realisation de l ACP
  cvCalcEigenObjects(this->objects.size(), obj, this->eigenObjects, CV_EIGOBJ_NO_CALLBACK, 0, NULL, &calcLimit, this->avg, this->eigVals);
  
  //Calcul des valeurs propres cumulees
  float valCumul = this->eigVals[0];
  for(unsigned int i=1;i<this->objects.size();i++)
    {
      valCumul += this->eigVals[i];
      this->eigVals[i] = valCumul;
    }
  //Recherche du nombre de valeurs propres correspondant a 90% d information
  for(this->nbValP = 0;this->eigVals[this->nbValP]/valCumul<=0.9;this->nbValP++);
  
  //Recherche du seuil maximal
  double maxDist=0.0, dist=0.0;
  this->mean = 0.0;
  printf("Compute maximum thresh\n");
  for(unsigned int i=0;i<this->nApp;i++)
    {
      this->mean += this->computeLikelihood(this->baseAppr[i]);
    }
  this->mean /= this->nApp;
  this->std = 0.0;
  for(int i=0;i < this->nApp;i++)
    {
      this->std += pow(this->computeLikelihood(this->baseAppr[i]) - this->mean,2);
    }
  this->std = sqrt(this->std/this->nApp);
  printf("mean : %lf, std : %lf\n", this->mean, this->std);
  this->state = eigenbase::OK;
}

//Charge la base d'images
void eigenbase::load(const char* dir, char* name, int nbObj, int nbApp)
{
  char location[256];

  this->setName(name);
  this->state = eigenbase::CHNG;
  if(this->eigenObjects)
    delete []  this->eigenObjects;
  this->eigenObjects = new IplImage*[nbObj];
  this->nObjects = nbObj;
  this->nApp = nbApp;
  IplImage* tmp;

  /* On charge les images utilisees pour l'ACP */
  for(int i=0,id=0;i<nbObj;i++) {
    sprintf(location, "%s/%s/acp-image%0.3d.jpg",dir,name,i);
    tmp = cvLoadImage(location, 0);
    if(tmp) {
      //printf("--> Eigenbase (ACP) : adding %s\n",location);
      this->objects.push_back(tmp);
      eigenbase::preTraiter(this->objects[id]);
      this->eigenObjects[id] = cvCreateImage( this->getSize(), IPL_DEPTH_32F, 1 );
      id++;
    }
    else {
      printf("|WARNING|--> Eigenbase (ACP) \t:\t missing %s\n",location);
    }
  }

  /* On charge les images pour la base d'apprentissage */
  for(int i=0,id=0;i<this->nApp;i++) {
    sprintf(location, "%s/%s/app-image%0.3d.jpg",dir,name,i);
    tmp = cvLoadImage(location, 0);
    if(tmp) {
      //printf("--> Eigenbase (APP) : adding %s\n",location);
      this->baseAppr.push_back(tmp);
      eigenbase::preTraiter(this->baseAppr[id]);
      id++;
    }
    else {
      printf("|WARNING|--> Eigenbase (APP) \t:\t missing %s\n",location);
    }
  }
}

//Sauvegarde la base
void eigenbase::save(char* path)
{
}

//Retourne les coefficients de decomposition de imgIn projetee dans la base
float* eigenbase::decompose(IplImage* imgIn)
{
  float * coeffs = (float*) malloc(this->nbValP * sizeof(float));
  for(int i=0;i<this->nbValP;i++)
    {
      coeffs[i] = 0.0;
    }
  cvEigenDecomposite(imgIn, this->nbValP, (void*) this->getEigenObjects(), CV_EIGOBJ_NO_CALLBACK, NULL, this->getAvg(), coeffs);
  return coeffs;
}

//Retourne la reconstruction de imgIn dans la base
IplImage* eigenbase::project(IplImage* imgIn)
{
  IplImage* proj = cvCreateImage(this->getSize(), IPL_DEPTH_8U, 1);
  float * coeffs = this->decompose(imgIn);
  cvEigenProjection((void*) this->getEigenObjects(), this->nbValP, CV_EIGOBJ_NO_CALLBACK, NULL, coeffs, this->getAvg(), proj);
  return proj;
}

//Accesseurs en lecture
vector<IplImage*> eigenbase::getObjects()
{
  return this->objects ;
}
vector<IplImage*> eigenbase::getAppr()
{
  return this->baseAppr ;
}
IplImage* eigenbase::getObject(int ind)
{
  return this->objects[ind];
}
int eigenbase::getNObjects()
{
  return this->objects.size();
}
int eigenbase::getNApp()
{
  return this->nApp;
}
IplImage** eigenbase::getEigenObjects()
{
  return this->eigenObjects;
}
IplImage* eigenbase::getAvg()
{
  return this->avg;
}
char* eigenbase::getName()
{
  return this->name;
}
CvSize eigenbase::getSize()
{
  return this->size;
}
float* eigenbase::getEigVals()
{
  return this->eigVals;
}
int eigenbase::getType()
{
  return(this->type);
}

//acesseurs en ecriture
void eigenbase::setObjects(IplImage** obj)
{
  for(unsigned int i=0;i<this->objects.size();i++)
    {
      this->objects[i] = cvCreateImage(this->getSize(), IPL_DEPTH_8U, 1);
      cvCopy(obj[i], this->objects[i]);
    }
}
void eigenbase::setEigenObjects(vector<IplImage*> eigenObj)
{
  for(unsigned int i=0;i<this->objects.size();i++)
    {
      this->eigenObjects[i] = cvCreateImage(this->getSize(), IPL_DEPTH_8U, 1);
      cvCopy(eigenObj[i], this->eigenObjects[i]);
    }
}
void eigenbase::setAvg(IplImage* moy)
{
  this->avg = cvCloneImage(moy);
}
void eigenbase::setName(char* nom)
{
  strcpy(this->name, nom);
}
void eigenbase::setSize(CvSize taille)
{
  this->size = cvSize(taille.width, taille.height);
}
void eigenbase::setEigVals(float* valP)
{
  this->eigVals = valP;
}
void eigenbase::setType(int t)
{
  this->type = t;
}
void eigenbase::setState(int etat)
{
  this->state = etat;
}

//Calcule la vraissemblance de l image par rapport a la base
double eigenbase::computeLikelihood(IplImage* imgIn)
{
  double dist = 0.0;
  IplImage *diff;

  switch(this->type)
    {
    case eigenbase::DFFS:
      {
	//Compute the DFFS
	diff = this->computeDFFS(imgIn);
      
	CvScalar std;
	cvAvgSdv(diff, NULL, &std);

	cvReleaseImage(&diff);
	return std.val[0];
      }
      break;
    default:
      ;
    }
  return sqrt(dist);
}

//Calcule l image difference caracteristique de la DFFS
IplImage* eigenbase::computeDFFS(IplImage* imgIn)
{
  //reconstruction de l image d entree
  IplImage* reconst = this->project(imgIn);
  //eigenbase::equalize(reconst);

  //Calcul de l imae difference
  IplImage* diff = cvCreateImage(this->getSize(), IPL_DEPTH_8U, 1);
  cvAbsDiff(imgIn, reconst, diff);

  //char win[256];
  //sprintf(win, "DFFS %s",this->getName());
  //cvShowImages(win, imgIn, reconst, diff, distance);
  cvReleaseImage(&reconst);
  IplImage* ell = cvCloneImage(diff);
  cvZero(ell);
  cvEllipse(ell, cvPoint(15,15), cvSize(13,11), 90.0, 0, 360, cvScalar(255), CV_FILLED);
  cvAnd(diff, ell, diff);
  cvReleaseImage(&ell);
  return diff;
}

//Ajoute l image a la base
void eigenbase::addObject(IplImage* imgIn)
{
  this->state = eigenbase::CHNG;
  this->objects.push_back(imgIn);
}

//Ajoute l image a la base d apprentissage
void eigenbase::addApp(IplImage* imgIn)
{
  this->state = eigenbase::CHNG;
  this->baseAppr.push_back(imgIn);
  this->nApp ++;
}
