#ifndef MHI_H
#define MHI_H

#include <cv.h>
#include <time.h>
#include <stdio.h>
#include <iostream>
using namespace std;

#include "displayutils.h"

class MotionHistoryImg
{

 public:
  // various tracking parameters (in seconds)
  double MHI_DURATION;
  double MAX_TIME_DELTA;
  double MIN_TIME_DELTA;
  // number of cyclic frame buffer used for motion detection
  // (should, probably, depend on FPS)
  int N;
  
  // ring image buffer
  IplImage **buf;
  int last;
  
  // temporary images
  IplImage* mhi; // MHI
  IplImage* orient; // orientation
  IplImage* mask; // valid orientation mask
  IplImage* segmask; // motion segmentation map
  CvMemStorage* storage; // temporary storage

  CvSize size;
  int width,height;
  int diff_threshold;

  IplImage* silh;
  CvSeq* seq;
  CvRect comp_rect;
  double count;
  double angle;
  CvPoint center;
  double magnitude;          
  CvScalar color;


  MotionHistoryImg(int width,int height,int threshold=30);
  ~MotionHistoryImg();


  //mise a jour du mvt
  void Update_mhi(IplImage* img, IplImage* dst);

  //Dessin du mvt
  //void DrawMotion(IplImage *dst);
};
#endif
