/***************************************************************************
                          video4linux.h  -  description
                             -------------------
    begin                : Mon May 13 2002
    copyright            : (C) 2002 by Paulo Menezes
    email                : pm@deec.uc.pt
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VIDEO4LINUX_H
#define VIDEO4LINUX_H
#ifdef linux
#include <sys/types.h>
#include <linux/videodev.h>
#include "video.h"
#include "yuv2rgb.h"
#include <iostream>

/**This class provides the interface to the video 4 linux
  *@author Paulo Menezes
  */

class video4linux : public video  {
public: 
  video4linux(int,int,bool optimus=false);
  ~video4linux();
  /** No descriptions */
  bool doOpen(int );
  /** No descriptions */
  IplImage * getImage();
private:
  int SetRGBfromYUV420(IplImage * image, void*memorymap);
  struct video_capability vcap;
  struct video_channel Channel;
  struct video_picture picture;
  char * memorymap;
  int width; //!< current width of the images to be captured
  int height;//!< current height of the images to be captured
  int maxbufs;
  int curbuf;
  IplImage * yuvimg;
  IplImage * rgbimg;
  bool  optimal;
public: // Public attributes
  /** descriptor of camera device */
  int camfd;
  /**  */
  struct video_mmap vmmap;
  /**  */
  struct video_mbuf mbuf;
};
#endif
#endif
