#include <iostream.h>
#include "applipath.h"
#include "def_paramslist.h"

#include "OpticalFlow.h"
#include "displayutils.h"
#include "temps_cpu.h"
#include "videoimgseq.h"

int main(void)
{
  /* Lecture d'une sequence d'images */
  videoimgseq myvid("/home/lbrethes/1pmobileET1pmobile/","seq01","jpg",524,700,5);
  myvid.init();
  IplImage* imgIn;

  /* Images */
  IplImage* mask=NULL; 
  IplImage* imgbw = cvCreateImage(cvSize(img_width,img_height),IPL_DEPTH_8U,1);
  IplImage* imgbw_medium = cvCreateImage(cvSize(img_width/2,img_height/2),IPL_DEPTH_8U,1);
  IplImage* edge = cvCreateImage(cvSize(img_width,img_height),IPL_DEPTH_8U,1);
  IplImage* Movingedge = cvCreateImage(cvSize(img_width,img_height),IPL_DEPTH_8U,1);

  /* Init image d'entree */
  imgIn = myvid.next();
  if(!imgIn)
    {
      cout << "Erreur de lecture de l'image\n";
      return 0;
    }

  /* Flot Optique */
  OpticalFlow* of = new OpticalFlow(img_width,img_height);

  char k=0;
  while(k!=27)
    {
      /* Chargement image courante */
      imgIn=myvid.next();
      if(!imgIn) return 0;
      
      cvCvtColor(imgIn,imgbw,CV_BGR2GRAY);
      cvPyrDown(imgbw,imgbw_medium,IPL_GAUSSIAN_5x5);
      cvPyrUp(imgbw_medium,imgbw,IPL_GAUSSIAN_5x5);
  
      /* canny */
      cvCanny(imgbw,edge,20,40);
      
      /* Filtrage par le flot */
      //calcul direct du flot et filtrage de edge
      of->computeandapplyflowmask(imgbw,edge,Movingedge);

      //En deux etapes : calcul du flot puis masquage (permet de conserver dans of le masque)
      // get_time_start();
      //of->flowmask(imgbw);
      //cvZero(Movingedge);
      //of->applyflowmask(edge,Movingedge);
      //get_time_stop();

      //Calcul du masque uniquement
      //mask = of->flowmask(imgbw);      

      //Le plus long en 3 etapes
      //get_time_start();
      //of->computeflow(imgbw);
      //of->flowmask();
      //cvZero(Movingedge);
      //of->applyflowmask(edge,Movingedge);
      //get_time_stop();

      //cout << endl << endl;

      Show("IN",imgIn,0);
      if(mask) Show("FLOW",mask,0);
      Show("EDGES",edge,0);
      Show("MOVING EDGES",Movingedge,0);
      Show("FLOWMASK",of->imgflowmask,0);
      k = cvWaitKey(50);
    }
}
