#include <iostream>
using namespace std;

#include "applipath.h"
#include "def_paramslist.h"


#include "Sample.h"
#include "ParticleFilter.h"
#include "SIR.h"
#include "ICOND.h"

void tracking_sir()
{
  ParticleFilter* pf = new SIRFilter("/home/lbrethes/DEVEL/icuTracking/config/filters/sir.txt");

  /* Lecture d'une image */
  IplImage* imgIn = cvLoadImage("img000.jpg",-1);

  pf->target->imgBank->set(imgIn);
  pf->InitSamplesFromPrior();
  //pf->DispSamples();


  string base = "/home/lbrethes/1pmobileET1pmobile/seq0100";
  string ext = ".jpg";
  char num[3];
  int deb = 524;
  int fin=700;
  string ficnm;

  Sample sps(4,0);
  double mm[4]={232,110,0,2.2};

  sps.ContinusP[0] = mm[0];
  sps.ContinusP[1] = mm[1];
  sps.ContinusP[2] = mm[2];
  sps.ContinusP[3] = mm[3];

  cvNamedWindow("IN",0);
  cvMoveWindow("IN",0,0);
  cvNamedWindow("RES",0);
  cvMoveWindow("RES",350,0);

  /* Init */
  sprintf(num,"%03d",deb);
  ficnm=base+num+ext;
  imgIn =  cvLoadImage(ficnm.c_str(),-1);
  IplImage* imgRes = cvCloneImage(imgIn);

  pf->target->imgBank->set(imgIn);
  pf->InitSamplesFromPrior(mm);
  //pf->target->imgBank->disp(1);
  pf->target->Trace(&sps,imgIn);
  cout << "Press key\n";
  cvShowImage("IN",imgIn);
  cvWaitKey(0);
  char kk=0;

  for(int i=deb+1;i<fin;i++)
    {
      /* Chargement de l'image */
      sprintf(num,"%03d",i);
      ficnm=base+num+ext;
      imgIn =  cvLoadImage(ficnm.c_str(),-1);
      cvCopyImage(imgIn,imgRes);
      cvShowImage("IN",imgIn);

      pf->target->imgBank->set(imgIn);

      /* Filtrage */
      pf->step();

      /* Resultat */
      pf->target->Trace(pf->pfState,imgRes);
      cvShowImage("RES",imgRes);
      kk=cvWaitKey(100);
      if(kk==27) break;
    }

}

void tracking_icond()
{
  //ParticleFilter* pf = new ICONDFilter("/home/lbrethes/DEVEL/icuTracking/config/filters/body_tracking_icond.txt");

  ParticleFilter* pf = new ICONDFilter("/home/lbrethes/DEVEL/icuTracking/config/filters/motion_monitoring_icond.txt");

  /* Lecture d'une image */
  IplImage* imgIn = cvLoadImage("img000.jpg",-1);

  pf->target->imgBank->set(imgIn);
  pf->InitSamplesFromPrior();
  //pf->DispSamples();


  string base = "/home/lbrethes/1pmobileET1pmobile/seq0100";
  string ext = ".jpg";
  char num[3];
  int deb = 524;
  int fin=700;
  string ficnm;

  Sample sps(3,0);
  double mm[3]={232,110,2.2};

  sps.ContinusP[0] = mm[0];
  sps.ContinusP[1] = mm[1];
  sps.ContinusP[2] = mm[2];

  cvNamedWindow("IN",0);
  cvMoveWindow("IN",0,0);
  cvNamedWindow("RES",0);
  cvMoveWindow("RES",350,0);

  /* Init */
  sprintf(num,"%03d",deb);
  ficnm=base+num+ext;
  imgIn =  cvLoadImage(ficnm.c_str(),-1);
  IplImage* imgRes = cvCloneImage(imgIn);

  pf->target->imgBank->set(imgIn);
  pf->InitSamplesFromPrior(mm);

  pf->target->Trace(&sps,imgIn);
  cvShowImage("IN",imgIn);
  cvWaitKey(0);
  char kk=0;

  for(int i=deb+1;i<fin;i++)
    {
      /* Chargement de l'image */
      sprintf(num,"%03d",i);
      ficnm=base+num+ext;
      imgIn =  cvLoadImage(ficnm.c_str(),-1);
      cvCopyImage(imgIn,imgRes);
      cvShowImage("IN",imgIn);

      /* On place l'image a traiter */
      pf->target->imgBank->set(imgIn);

      /* Execution de la detection */
      pf->target->detector->process();
      //cout << "Found " << pf->target->detector->nbdetected << " faces\n";

      /* Filtrage */
      pf->step();

      /* Resultat */
      pf->target->Trace(pf->pfState,imgRes);
      cvShowImage("RES",imgRes);
      kk=cvWaitKey(100);
      if(kk==27) break;
    }

}

int main(void)
{
  tracking_sir();
  //tracking_icond();
}
