//nclude "SampleUnscented.h"
#include "squarerootutils.h"


void test_solve()
{
  double X[6];
  double Up[]={1,2,1,0,1,0,0,0,4};
  double Res[]={1,4,13,4,13,12};
  double Res2[6];

  printf("------------------------------------\n");
  printf("--     SOLVEUPPER                 --\n");
  printf("------------------------------------\n");
  
  printf("Up : \n");
  DispMatrix(Up,3,3);

  printf("Res : \n");
  DispMatrix(Res,3,2);
  
  SolveUpperSystem<double>(X,Up,Res,2,3);

  printf("X : \n");
  DispMatrix(X,3,2);


  MatrixMult(X,Up,Res2,2,3,3);
  printf("Res2 : \n");
  DispMatrix(Res2,3,2);

  printf("------------------------------------\n");
  printf("--     SOLVELOWER                 --\n");
  printf("------------------------------------\n");

  SquareUpperMatrixTranspose<double>(Up,3);

  printf("Low : \n");
  DispMatrix(Up,3,3);

  double Res3[]={8,2,12,16,5,8};
  double X2[6];

  printf("Res : \n");
  DispMatrix(Res3,3,2);
  
  SolveLowerSystem<double>(X2,Up,Res3,2,3);

  printf("X : \n");
  DispMatrix(X2,3,2);


  MatrixMult(X2,Up,Res2,2,3,3);
  printf("Res2 : \n");
  DispMatrix(Res2,3,2);  

}



void test_cholupdate()
{

  double mat1[]={6,15,14,15,45,37,14,37,35};
  double mat2[]={1,2,3,4,5,6,0,0,2};
  double chol[9];
  double cholTranspose[9];
  double matresult[9];

  double vect[3]={1,2,3};

  printf("------------------------------------\n");
  printf("--     CHOLUPDATE                 --\n");
  printf("------------------------------------\n");

  printf("matrice1 : \n");
  DispMatrix(mat1,3,3);

  Cholesky<double>(mat1,chol,3);

  printf("decomp de cholesky de mat1: \n");
  DispMatrix(chol,3,3);

  
  SquareMatrixTranspose<double>(chol, cholTranspose,3);
  SquareMatrixMult<double>(chol,cholTranspose,matresult,3);

  printf("chol * cholTranpose : \n");
  DispMatrix(matresult,3,3);


  printf("vecteur ajoute : \n");
  DispMatrix(vect,3,1);

  

  for (int i=0; i<3; i++)
    for (int j=0; j<3; j++)
      mat2[i*3+j]=mat1[i*3+j]+vect[i]*vect[j];
  
  printf("matrice1 + vect*vectTranspose : \n");
  DispMatrix(mat2,3,3);
  
  RankOneLowerCholeskyUpdate<double>(chol,vect,3);
  printf("----update de Cholesky----\n");

  printf("new vecteur ajoute : \n");
  DispMatrix(vect,3,1);

  printf("new chol : \n");
  DispMatrix(chol,3,3);

  SquareMatrixTranspose<double>(chol, cholTranspose,3);
  printf("new chol Transpose : \n");
  DispMatrix(cholTranspose,3,3);

  SquareMatrixMult<double>(chol,cholTranspose,matresult,3);
  printf("new chol * cholTranpose : \n");
  DispMatrix(matresult,3,3);
  
  


  printf("------------------------------------\n");
  printf("--     CHOLDOWNDATE               --\n");
  printf("------------------------------------\n");

  printf("matrice1 : \n");
  DispMatrix(mat1,3,3);
  
  Cholesky<double>(mat1,chol,3);
  
  
  vect[0] = 1;
  vect[1] = 2;
  vect[2] = 3;  
  printf("vecteur soustrait : \n");
  DispMatrix(vect,3,1);

  
  for (int i=0; i<3; i++)
    for (int j=0; j<3; j++)
      mat2[i*3+j]=mat1[i*3+j]-vect[i]*vect[j];
  
  printf("matrice1 - vect*vectTranspose : \n");
  DispMatrix(mat2,3,3);
 

  printf("----downdate de Cholesky----\n");
  SquareMatrixTranspose<double>(chol, cholTranspose,3); 
  printf("retour de la fonction cholDowndate : %d \n",RankOneUpperCholeskyDowndate<double>(cholTranspose,vect,3));

  printf("new vecteur soustrait : \n");
  DispMatrix(vect,3,1);

  printf("new cholTranspose : \n");
  DispMatrix(cholTranspose,3,3);

  SquareMatrixTranspose<double>(cholTranspose, chol,3);
  printf("new chol : \n");
  DispMatrix(chol,3,3);

  SquareMatrixMult<double>(chol,cholTranspose,matresult,3);
  printf("new chol * cholTranpose : \n");
  DispMatrix(matresult,3,3);
}


#define Type_Reel double
void test_qr()
{

  printf("------------------------------------\n");
  printf("--     DECOMPOSITION QR           --\n");
  printf("------------------------------------\n");



  Type_Reel mat1[]={1,2,3,-1, 5,-6,1,-2, 3,-7,8,-9, 1,1,-4,5, 0,4,-10,5};
  Type_Reel qr[20];

  Type_Reel q[20];
  Type_Reel qTranspose[20];
  Type_Reel diag[4];
  Type_Reel r[16];
  Type_Reel r2[16];

  Type_Reel result[20];

  printf("matrice 1 : \n");
  DispMatrix(mat1, 4,5);

  QR<Type_Reel>(mat1,diag,qr,5,4);

/*  printf("matrice QR : \n");
  DispMatrix(qr, 4,5);
  
*/
  GetR<Type_Reel>(qr,diag,r,4);
  printf("matrice R : \n");
  DispMatrix(r, 4,4);
  
  GetQ<Type_Reel>(qr,q,5,4);
  printf("matrice Q : \n");
  DispMatrix(q, 4,5);

 /* MatrixTranspose(q,qTranspose,4,3);
    printf("matrice QTranspose : \n");
    DispMatrix(qTranspose, 4,3);
    
    MatrixMult<Type_Reel>(qTranspose,q,result,3,4,3);
    printf("Q * QTranspose : \n");
    DispMatrix(result, 4,4);*/

  MatrixMult<Type_Reel>(q,r,result,5,4,4);
  printf("Q * R : \n");
  DispMatrix(result, 4,5);
  

  //meme chose qu au dessus mais en une seule instruction :
  GetRFromQRDecomposition<Type_Reel>(r2,mat1,5,4);
  printf("matrice R (calcul identique mais appel different): \n");
  DispMatrix(r2, 4,4);

}



void test_qr_ludo()
{

  printf("----------------------------------------------------\n");
  printf("--     DECOMPOSITION QR NOUVELLE VERSION          --\n");
  printf("----------------------------------------------------\n");



  Type_Reel mat1[]={1,2,3,-1, 5,-6,1,-2, 3,-7,8,-9, 1,1,-4,5, 0,4,-10,5};
  Type_Reel qr[20];

  Type_Reel q[20];
  Type_Reel qTranspose[20];
  Type_Reel diag[4];
  Type_Reel r[16];
  Type_Reel r2[16];

  Type_Reel result[20];

  printf("matrice 1 : \n");
  DispMatrix(mat1, 4,5);

  CopyMatrix<Type_Reel>(mat1,5,4,qr);

  printf("qr copie de mat1 : \n");
  DispMatrix(qr, 4,5);

  QR<Type_Reel>(qr,diag,5,4);

  printf("matrice QR apres decomposition : \n");
  DispMatrix(qr, 4,5);
  
  GetR<Type_Reel>(qr,diag,r,4);
  printf("matrice R : \n");
  DispMatrix(r, 4,4);
  
  GetQ<Type_Reel>(qr,q,5,4);
  printf("matrice Q : \n");
  DispMatrix(q, 4,5);

 /* MatrixTranspose(q,qTranspose,4,3);
    printf("matrice QTranspose : \n");
    DispMatrix(qTranspose, 4,3);
    
    MatrixMult<Type_Reel>(qTranspose,q,result,3,4,3);
    printf("Q * QTranspose : \n");
    DispMatrix(result, 4,4);*/

  MatrixMult<Type_Reel>(q,r,result,5,4,4);
  printf("Q * R : \n");
  DispMatrix(result, 4,5);
  

  //meme chose qu au dessus mais en une seule instruction :
  GetRFromQRDecomposition<Type_Reel>(r2,mat1,5,4);
  printf("matrice R (calcul identique mais appel different): \n");
  DispMatrix(r2, 4,4);

}

template <class T>
void SquareMatrixTransposeMultUpper(T* in1, T* out, int size)
{
  SetZero<T>(out,size*size);

  for (int i=0; i<size; i++)
    for (int j=0; j<size; j++)
      for (int k=0; k<size; k++)
	out[i*size+j] += in1[k*size+i]*in1[k*size+j];

}

template <class T>
void SquareMatrixTransposeMultLower(T* in1, T* out, int size)
{
  SetZero<T>(out,size*size);

  for (int i=0; i<size; i++)
    for (int j=0; j<size; j++)
      for (int k=0; k<size; k++)
	out[i*size+j] += in1[i*size+k]*in1[j*size+k];

}

int main(int argc, char** argv)
{

//  test_solve();
//  test_qr_ludo();

  double mat[16] = {3.16227766016838,   1.58113883008419,   0.63245553203368,
		    0,   3.08220700148449,   1.62221421130763,
		    0,                  0,   3.45954058404170};

  double res[16]; 
  double res2[16];
  double matT[16];

  SquareMatrixTranspose<double>(mat,matT,3);
  printf("Mat :\n");
  MatrixMult<double>(matT,mat,res,3,3,3);
  printf("\n");
  DispMatrix<double>(mat,3,3);
  printf("\n");
  DispMatrix<double>(matT,3,3);
  printf("\n");
  DispMatrix<double>(res,3,3);

  printf("Methode 2\n");
  SquareMatrixTransposeMultUpper(mat,res2,3);
  DispMatrix<double>(res2,3,3);


  printf("Methode 2 bis\n");
  SquareMatrixTransposeMultLower(matT,res2,3);
  DispMatrix<double>(res2,3,3);



  double chc[]= {1.61965, 0,       0,       0,
		 1.29781e-18,     0.00982946,      0,       0,
		 0.763538,        6.44479e-18,     0.82013, 0,
		 5.07422e-32,     9.83187e-16,     3.84693e-31,     3.16244e-07};

  double rr[] = {1.8880,    0.0008,    1.4070,         0};
  double yprim[4];

  SolveLowerSystem(yprim,chc,rr,1,4);
  DispVector<double>(yprim,4);


  return 0;
} 
