/***************************************************************************
                          videofile.cpp  -  description
                             -------------------
    begin                : Tue Aug  19 10:28:34 CET 2003
    copyright            : (C) 2003 by Paulo Menezes
    email                : paulo@isr.uc.pt
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "videofile.h"

videofile::videofile(char * fname){
  image=NULL;
  strncpy(filename,fname,256);
  c=NULL;
  ic=NULL;
  pkt=&pkt1;
  size=0;
}

bool videofile::doOpen(){
  int ret;

  av_register_all();
  /* must be called before using avcodec lib */
  avcodec_init();
  
  /* register all the codecs (you can also register only the codec
     you wish to have smaller code */
  
  avcodec_register_all();

  if ((ret=av_open_input_file(&ic,filename,NULL,0,NULL))<0){
    print_error(filename,ret);
    return false;
  }

 if (av_find_stream_info(ic)<0){
    printf("Cannot find codec parameters\n");
    return false;
  }
 for (int i=0;i<ic->nb_streams;i++){
   AVCodecContext * enc=&ic->streams[i]->codec;
   if (enc->codec_type==CODEC_TYPE_VIDEO)
     video_index=i;// save the video index for getting only the video packets later
 }
 c= &ic->streams[video_index]->codec;
 /* find the       video decoder */
 codec = avcodec_find_decoder(c->codec_id);
 if (!codec) {
   fprintf(stderr, "codec not found\n");
   return false;
  }
 picture= avcodec_alloc_frame();
 if (avcodec_open(c, codec) < 0) {
   fprintf(stderr, "could not open codec\n");
   return false;
 }

 // alloc the image structure in accordance with the video file
 // resolution
 // image=cvCreateImage(cvSize(c->width,c->height),IPL_DEPTH_8U,3);

}


IplImage * videofile::getImage(){
  int ret;
  int len;
  int got_picture;
  for(;;){
    while (size<=0){ // repeat until we got a packet of video data
      ret=av_read_packet(ic,pkt);
      if (ret < 0)
	return NULL;
      
      if (pkt->stream_index==video_index){
	// queue packet and process it
	inbuf_ptr = pkt->data;
	size=pkt->size;
      } else 
	av_free_packet(pkt);
    }

    while(size>0){
      len = avcodec_decode_video(c, picture, &got_picture, 
				 inbuf_ptr, size);
      
      if (len < 0) 
	break; 
      size -= len;
      inbuf_ptr += len;
      if (got_picture) {
	if (image==NULL){
	  printf("ca y est\n");
	  int tam;
	  char * ptr;
	  tam=c->width*c->height;
	  image=cvCreateImage(cvSize(c->width,c->height),IPL_DEPTH_8U,3);
	  tam=avpicture_get_size(PIX_FMT_RGB24,c->width,c->height);
	  ptr=(char *)malloc(tam);
	  avpicture_fill(&pict,(uint8_t*)ptr,PIX_FMT_RGB24,c->width,c->height);
	}
	
	ret=img_convert(&pict,PIX_FMT_RGB24,(AVPicture *)picture,c->pix_fmt,c->width,c->height);
	//img_convert((AVPicture *)picture,c->pix_fmt,&pict,PIX_FMT_RGBA32,c->width,c->height);
	char * ptr;
	for (int i=0;i<c->height;i++){
	  ptr=image->imageData+i*image->widthStep;
	  for (int j=0;j<c->width;j++){
	    *ptr=(pict.data[0])[i*pict.linesize[0]+j*3];
	    ptr++;
	    *ptr=(pict.data[0])[i*pict.linesize[0]+j*3+1];
	    ptr++;
	    *ptr=(pict.data[0])[i*pict.linesize[0]+j*3+2];
	    ptr++;
	  }
	}

	return image;
      }
    }// while(size>0)
  }// for(;;) 
} // getImage

  videofile::~videofile(){
    av_close_input_file(ic);
    avcodec_close(c);
    //free(c);
    av_free(picture);
  }

void videofile::print_error(const char *filename, int err)
{
    switch(err) {
    case AVERROR_NUMEXPECTED:
        fprintf(stderr, "%s: Incorrect image filename syntax.\n"
                "Use '%%d' to specify the image number:\n"
                "  for img1.jpg, img2.jpg, ..., use 'img%%d.jpg';\n"
                "  for img001.jpg, img002.jpg, ..., use 'img%%03d.jpg'.\n", 
                filename);
        break;
    case AVERROR_INVALIDDATA:
        fprintf(stderr, "%s: Error while parsing header\n", filename);
        break;
    case AVERROR_NOFMT:
        fprintf(stderr, "%s: Unknown format\n", filename);
        break;
    default:
        fprintf(stderr, "%s: Error while opening file\n", filename);
        break;
    }
}

